<?php

function filewrite($filename, $data)
{
// supply a file name and I'll write your data to it
 $fd = fopen($filename, 'w');
 $check = fwrite ($fd, $data);
 fclose ($fd);
 return $check;
}

function encodesqlline($sqltext)
{
 $sqltext = str_replace('&lt;', '&lt&', $sqltext);
 $sqltext = str_replace('&gt;', '&gt&', $sqltext);
 $sqltext = str_replace('&#59;', '&#59&', $sqltext);
 $sqltext = str_replace('&#125;', '&#125&', $sqltext);
 $sqltext = str_replace('&#123;', '&#123&', $sqltext);
 $sqltext = str_replace('&quot;', '&quot&', $sqltext);  
 $sqltext = str_replace('&amp;', '&amp&', $sqltext);
 $sqltext = str_replace('&#39;', '&#39&', $sqltext);
 $sqltext = str_replace('&#34;', '&#34&', $sqltext);
 $sqltext = str_replace('&#8242;', '&#8242&', $sqltext);
 $sqltext = str_replace(';', '{semicolon}', $sqltext);
 return $sqltext;
}

function encodesql($sqltext)
{
 $sqltext = str_replace('&lt;', '&lt&', $sqltext);
 $sqltext = str_replace('&gt;', '&gt&', $sqltext);
 $sqltext = str_replace('&#59;', '&#59&', $sqltext);
 $sqltext = str_replace('&#125;', '&#125&', $sqltext);
 $sqltext = str_replace('&#123;', '&#123&', $sqltext);
 $sqltext = str_replace('&quot;', '&quot&', $sqltext);  
 $sqltext = str_replace('&amp;', '&amp&', $sqltext);
 $sqltext = str_replace('&#39;', '&#39&', $sqltext);
 $sqltext = str_replace('&#34;', '&#34&', $sqltext);
 $sqltext = str_replace('&#8242;', '&#8242&', $sqltext);
 return $sqltext;
}

function processsql($sqltext)
{
 global $db, $prefix;
 $sqltext = str_replace('{PREFIX}', $prefix, $sqltext);
 $sqlarray = explode(';', $sqltext);
 $num = sizeof($sqlarray);
 for ($count=0; $count<($num-1); $count++)
 {
  $sqlarray[$count] = str_replace('&lt&', '&lt;', $sqlarray[$count]);
  $sqlarray[$count] = str_replace('&gt&', '&gt;', $sqlarray[$count]);
  $sqlarray[$count] = str_replace('&#59&', '&#59;', $sqlarray[$count]);
  $sqlarray[$count] = str_replace('&#125&', '&#125;', $sqlarray[$count]);
  $sqlarray[$count] = str_replace('&#123&', '&#123;', $sqlarray[$count]);
  $sqlarray[$count] = str_replace('&quot&', '&quot;', $sqlarray[$count]);  
  $sqlarray[$count] = str_replace('&amp&', '&amp;', $sqlarray[$count]);
  $sqlarray[$count] = str_replace('&#39&', '&#39;', $sqlarray[$count]);
  $sqlarray[$count] = str_replace('&#34&', '&#34;', $sqlarray[$count]);
  $sqlarray[$count] = str_replace('&#8242&', '&#8242;', $sqlarray[$count]);
  $sqlarray[$count] = str_replace('{semicolon}', ';', $sqlarray[$count]);
  $sqlarray[$count] = stripslashes($sqlarray[$count]);
  $db->query($sqlarray[$count]);
 }
 return mysql_error();
}


function getunvallinks()
{
 global $db, $settings;
 $doit = $db->select($settings->linkfields, 'linkstable', 'validated=0', 'ORDER BY id ASC', '');
 return $doit;
}

function getunvalcats()
{
 global $db, $settings;
 $doit = $db->select($settings->categoryfields, 'categoriestable', 'validated=0', 'ORDER BY id ASC', '');
 return $doit;
}

function getcatinfo($field, $fieldvalue, $condition)
{
 global $db, $settings;
 if ($condition == 'equals') $condition="$field='$fieldvalue'";
 if ($condition == 'like') $condition="$field LIKE '%$fieldvalue%'";
 return $db->select($settings->categoryfields, 'categoriestable', $condition, '', '');
}

function getlinkinfo ($field, $fieldvalue, $condition)
{
 global $db, $settings;
 if ($field == 'catid')
 {
  $query = $db->select('id', 'categoriestable', "name='$fieldvalue'", '', '');
  $fieldvalue = $db->rowitem($query);
 }
 if ($condition == 'equals') $condition="$field='$fieldvalue'";
 if ($condition == 'like') $condition="$field LIKE '%$fieldvalue%'";
 if ($condition == 'greater') $condition="$field > '$fieldvalue'";
 if ($condition == 'less') $condition="$field < '$fieldvalue'";
 return $db->select($settings->linkfields, 'linkstable', $condition, '', '');
}

function getcommentinfo($field, $fieldvalue, $condition)
{
 global $db, $settings;
 if ($condition == 'equals') $condition="$field='$fieldvalue'";
 if ($condition == 'like') $condition="$field LIKE '%$fieldvalue%'";
 return $db->select($settings->commentfields, 'commentstable', $condition, '', '');
}

function getmemberinfo($field, $fieldvalue, $condition)
{
 global $db, $settings;
 if ($condition == 'equals') $condition="$field='$fieldvalue'";
 if ($condition == 'like') $condition="$field LIKE '%$fieldvalue%'";
 return $db->select($settings->memberfields, 'memberstable', $condition, '', '');
}

function geturl($url)
{
 $fd = @fopen($url, 'r');
 $filecontents = @fread ($fd, 1000000);
 @fclose ($fd);
 return $filecontents;
}

function generatelinksoptions()
{
 global $settings;
 $linkfields = explode(',', $settings->linkfields);
 $num = sizeof($linkfields);
 for ($count=0; $count<$num; $count++)
 {
  $field = $linkfields[$count];
  if (!(strstr($settings->excludedtoadmin, '|'. $field . '|')))
  {
   $fieldname = $field;
   if ($field == 'catid') $fieldname = 'category name';
   if ($field == 'recipurl') $fieldname = 'reciprocal url';
   if ($field == 'numcomments') $fieldname = 'number of comments';
   $linksoptions .= "<option value=$field>$fieldname</option>";
  }
 }
 return $linksoptions;
}

function orderlinksoptions($selected)
{
 global $settings;
 $linkfields = explode(',', $settings->linkfields);
 $num = sizeof($linkfields);
 for ($count=0; $count<$num; $count++)
 {
  $field = $linkfields[$count];
  $fieldfull = "ORDER BY $field ASC";
  $english = "By $field ascending";
  if ($fieldfull == $selected) $isselected = " selected"; else $isselected = '';
  $linksoptions .= "<option value='$fieldfull' $isselected>$english</option>";
  $fieldfull = "ORDER BY $field DESC";
  $english = "By $field descending";   
  if ($fieldfull == $selected) $isselected = " selected"; else $isselected = '';
  $linksoptions .= "<option value='$fieldfull' $isselected>$english</option>";
 }
 return $linksoptions;
}

function ordercommentsoptions($selected)
{
 global $settings;
 $commentfields = explode(',', $settings->commentfields);
 $num = sizeof($commentfields);
 for ($count=0; $count<$num; $count++)
 {
  $field = $commentfields[$count];
  $fieldfull = "ORDER BY $field ASC";
  $english = "By $field ascending";
  if ($fieldfull == $selected) $isselected = " selected"; else $isselected = '';
  $commentsoptions .= "<option value='$fieldfull' $isselected>$english</option>";
  $fieldfull = "ORDER BY $field DESC";
  $english = "By $field descending";   
  if ($fieldfull == $selected) $isselected = " selected"; else $isselected = '';
  $commentsoptions .= "<option value='$fieldfull' $isselected>$english</option>";
 }
 return $commentsoptions;
}

function ordercatsoptions($selected)
{
 global $settings;
 $categoryfields = explode(',', $settings->categoryfields);
 $num = sizeof($categoryfields);
 for ($count=0; $count<$num; $count++)
 {
  $field = $categoryfields[$count];
  $fieldfull = "ORDER BY $field ASC";
  $english = "By $field ascending";
  if ($fieldfull == $selected) $isselected = " selected"; else $isselected = '';
  $categoryoptions .= "<option value='$fieldfull' $isselected>$english</option>";
  $fieldfull = "ORDER BY $field DESC";
  $english = "By $field descending";   
  if ($fieldfull == $selected) $isselected = " selected"; else $isselected = '';
  $categoryoptions .= "<option value='$fieldfull' $isselected>$english</option>";
 }
 return $categoryoptions;
}

function generatecatsoptions()
{
 global $settings;
 $categoryfields = explode(',', $settings->categoryfields);
 $num = sizeof($categoryfields);
 for ($count=0; $count<$num; $count++)
 {
  $field = $categoryfields[$count];
  if (!(strstr($settings->excludedtoadmin, '|'. $field . '|')))
  {
   $fieldname = $field;
   if ($field == 'numlinks') $fieldname = 'number of links';
   $categoriesoptions .= "<option value=$field>$fieldname</option>";
  }
 }
 return $categoriesoptions;
}

function generatecommentoptions()
{
 global $settings;
 $commentfields = explode(',', $settings->commentfields);
 $num = sizeof($commentfields);
 for ($count=0; $count<$num; $count++)
 {
  $field = $commentfields[$count];
  if (!(strstr($settings->excludedtoadmin, '|'. $field . '|')))
  {
   $fieldname = $field;
   if ($field == 'postername') $fieldname = 'poster name';
   if ($field == 'linkname') $fieldname = 'link name';  
  $commentoptions .= "<option value=$field>$fieldname</option>";
  }
 }
 return $commentoptions;
}


function generatememberoptions()
{
 global $settings;
 $memberfields = explode(',', $settings->memberfields);
 $num = sizeof($memberfields);
 for ($count=0; $count<$num; $count++)
 {
  $field = $memberfields[$count];
  if (!(strstr($settings->excludedtoadmin, '|'. $field . '|')))
  {
   $fieldname = $field;
   if ($field == 'postername') $fieldname = 'poster name';
   if ($field == 'linkname') $fieldname = 'link name';  
  $memberoptions .= "<option value=$field>$fieldname</option>";
  }
 }
 return $memberoptions;
}

function sendvalidationemail($thislink)
{
 global $language, $settings;
 $adminaddress = $settings->email;
 $submitter = $thislink->email;
 $subject = $language->email_notifyusertitle;
 $message = $language->email_notifyuserbody;
 $message = linkreplacements($message, $thislink);   
 $message = str_replace('{DIRURL}', $settings->dirurl, $message);
 $thecat = new category('id', $thislink->catid);
 $message = categoryreplacements($message, $thecat);
 $message = decodeit($message);
 mail("$submitter", "$subject", "$message", "From: $adminaddress");
}

function emailmembervalidation($thismem)
{
 global $language, $settings;
 $adminaddress = $settings->email;
 $submitter = $thismem->email;
 $subject = $language->email_validatemembertitle;
 $message = $language->email_validatememberbody;
 $message = memberreplacements($message, $thismem);   
 $message = str_replace('{DIRURL}', $settings->dirurl, $message);
 $message = decodeit($message);
 mail("$submitter", "$subject", "$message", "From: $adminaddress");
}


function updatelinkcounters($next)
{
 global $db, $settings;
 // recalculate comment totals for links
 $query = $db->select($settings->linkfields, 'linkstable', 'id>0', '', '');
 $num = $db->numrows($query);
 for ($count=$next; (($count<$num) && ($count<($next+50))); $count++)
 {
  $row = $db->row($query);
  $lin = new onelink('row', $row);
  $q2 = $db->select('id', 'commentstable', 'linkid='. $lin->id .' AND validated=1', '', '');
  $tot = $db->numrows($q2);
  $lin->numcomments = $tot;
  $lin->update('numcomments');
 }
 return true;
}

function updatecatcounters($next)
{
 global $db, $settings;

 // recalculate link totals and parents for categories
 $query = $db->select($settings->categoryfields, 'categoriestable', 'id>0', '', '');
 $num = $db->numrows($query);
 for ($count=$next; (($count<$num) && ($count<($next+50))); $count++)
 {
  $row = $db->row($query);
  $cat = new category('row', $row);
  $cat->numlinks = totalincat($cat->id);
  $cat->updateparents();
  $cat->update('numlinks,parentids,parentnames');
 }
 return true;
}

function updatememcounters($next)
{ 
 global $db, $settings;
 // re-calculate number of links, comments and hits for member profiles
 $query = $db->select($settings->memberfields, 'memberstable', 'id>0', '', '');
 $num = $db->numrows($query);
 for ($count=$next; (($count<$num) && ($count<($next+50))); $count++)
 {
  $row = $db->row($query);
  $mem = new member('row', $row);
  $q2 = $db->select('hits,hitsin', 'linkstable', "ownerid=". $mem->id ." AND hide=0 AND validated=1", '', '');
  $tot = $db->numrows($q2);
  $mem->links = $tot;
  for ($x=0; $x<$tot; $x++)
  {
    $row = $db->row($q2);
    $allhits += $row[0];
    $allhitsin += $row[1];
  }
  $mem->totalhits = $allhits;
  $mem->totalhitsin = $allhitsin;
  $q3 = $db->select('id', 'commentstable', 'ownerid='. $mem->id .' AND validated=1', '', '');
  $totcom = $db->numrows($q3);
  $mem->comments = $totcom;
  $mem->update('links,totalhits,totalhitsin,comments');
 } 
 return true;
}

function debugmenu($current)
{
 if (($current == 0) || ($current == 'no')) $stuff = '<option value=0 selected>None</option>';
 else $stuff .= '<option value=0>None</option>';
 if ($current == 1) $stuff .= '<option value=1 selected>Show queries as executed</option>';
 else $stuff .= '<option value=1>Show queries as executed</option>';
 if ($current == 2) $stuff .= '<option value=2 selected>Show queries at bottom after page is complete</option>';
 else $stuff .= '<option value=2>Show queries at bottom after page is complete</option>';
 if ($current == 3) $stuff .= '<option value=3 selected>Only show queries to admin, not to other users</option>';
 else $stuff .= '<option value=3>Only show queries to admin, not to other users</option>';
 if ($current == 4) $stuff .= '<option value=4 selected>Only show totals and execution time</option>';
 else $stuff .= '<option value=4>Only show totals and execution time</option>';

 return $stuff;
}

function registrationmenu($current)
{
 if ($current == 'direct') $stuff = "<option value='direct' selected>Direct</option>";
 else $stuff .= "<option value='direct'>Direct</option>";
 if ($current == 'email') $stuff .= "<option value='email' selected>E-mail activation code</option>";
 else $stuff .= "<option value='email'>E-mail activation code</option>";
 if ($current == 'validate') $stuff .= "<option value='validate' selected>Require validation by admin</option>";
 else $stuff .= "<option value='validate'>Require validation by admin</option>";
 return $stuff;
}

function fieldselector($type, $selected)
{
 global $settings;
 $selected = ' '. str_replace(',', ' ', $selected) . ' ';
 $fields = explode(',', $settings->$type);
 $num = sizeof($fields);
 for ($x=0; $x<$num; $x++)
 {
  if (strstr($selected, ' '. $fields[$x] .' ')) $stuff .= '<option value="'. $fields[$x] .'" selected>'. $fields[$x] .'</option>'; 
  else $stuff .= '<option value="'. $fields[$x] .'">'. $fields[$x] .'</option>';
 }
 return $stuff;
}

function extractphp($phpDocument)
{
 $questMark = "?";
 $phpOpenTag = "<${questMark}php";
 $phpCloseTag = "${questMark}>";
 
 return ("$phpCloseTag" . stripslashes($phpDocument) . "$phpOpenTag ");
}

?>