<?php

require 'adminstart.php';
require '../classes/comments.php';

$noparsing = true; // we don't want codes parsed when editing

$canedit = false;
if ($thismember->groupisadmin)
{
 $canedit = true;
}
else
{
 if ($field == 'id')
 {
  if ($action == 'link') $something = new onelink('id', $fieldvalue);
  else if ($action == 'member') $amem = new member('id', $fieldvalue);
  else if ($action == 'category') $cat = new category('id', $fieldvalue);
  else if ($action == 'comment') $com = new comment('id', $fieldvalue);
  $canedit = $thismember->canedit($action, $fieldvalue);
 }
 else
 {
  if ($action == 'link') $something = new onelink('id', $id);
  else if ($action == 'member') $amem = new member('id', $id);
  else if ($action == 'category') $cat = new category('id', $id);
  else if ($action == 'comment') $com = new comment('id', $id);
  $canedit = $thismember->canedit($action, $id);
 }
}

if ($canedit)
{
 if ($action == 'copylink')
 {
  $thislink = new onelink('dummy', $id);
  if (!$template) $template = new template("../$templatesdir/admin/edit.tpl");
  $template->replace("edit.php?action=link&filled=1", "../suggest.php?action=addlink&filled=1");
  $template->replace("Edit", "Add Copied");
  if ($thislink->recip == 0) $selected = 'no'; else $selected = 'yes';
  $recipselector = yesno($selected);
  $selector = $settings->categoryselector;
  $template->text = linkreplacements($template->text, $thislink);
  $hideselector = yesno($thislink->hide);
  $selector = makeselection($settings->categoryselector, $thislink->catid);
  $template->replace('{LINKTYPESELECTOR}', typeselector($thislink->type));
  $template->replace('{LINKHIDESELECTOR}', $hideselector);
  $template->replace('{CATSELECTOR}', $selector);
  $template->replace('{RETURNTO}', $returnto);
  $template->replace('{OLDCATID}', $thislink->catid);
  $template->replace('{LINKRECIPSELECTOR}', $recipselector);
  $template->replace('{CATSELECTOR}', $selector);
  $template->replace('{LINKID}', "''");
  $template->text = linkreplacements($template->text, $thislink); 
 }
 else if ($action == 'link')
 { 
  if ($filled)
  {
    if ($delete=='on')
    {
     $thislink = new onelink('dummy', $id);	
     $result = $thislink->deletethis();
     $owner = $thislink->ownerid;
     $amem = new member('id', $owner);
     $amem->links -= 1;
     $amem->update('links');
     if (!$template) $template = new template("../$templatesdir/redirect.tpl");
     $ourlang = str_replace('{ITEM}', 'link', $language->admin_delete);
     $template->replace('{MESSAGE}', $ourlang);
     if ($returnto == '') $returnto = 'index.php';   
     $template->replace("{DESTINATION}", $returnto);
    }
    else
    {
     $thislink = new onelink('new', '');
     $thislink->sumofvotes = ($thislink->votes) * ($thislink->rating);
	 $thislink->lastedit = time();
	 if ($thismember->groupvalidateedits)
	 {
	  $thislink->validated = 0;
      $adminaddress = $settings->email;
      if ( ($settings->notify == 'yes') && ($adminaddress != '') )
      {  
       $subject = $language->email_newsuggestiontitle;
       $message = $language->email_newsuggestionbody;
       $message = str_replace('{TYPE}', 'link', $message);   
       $message = str_replace('{DIRURL}', $settings->dirurl, $message);
       $message = linkreplacements($message, $thislink);
       mail("$adminaddress", "$subject", "$message", "From: $adminaddress");
      } 
	 }
     $result = $thislink->update('all');
     if (!$template) $template = new template("../$templatesdir/redirect.tpl");
     $ourlang = str_replace('{ITEM}', 'link', $language->admin_edit);
     if ($thismember->groupvalidateedits) $ourlang = $language->edit_pendingvalidation;
     $template->replace('{MESSAGE}', $ourlang);
     if ($returnto == '') $returnto = 'index.php';   
     $template->replace('{DESTINATION}', $returnto);
    }
  }
  else
  { 
   $linkinfo = getlinkinfo($field, $fieldvalue, $condition);
   $nummatching = $db->numrows($linkinfo);
   if ($nummatching > 1)
   {
    if (!$template) $template = new template("../$templatesdir/admin/search.tpl");
    for ($count=0; $count<$nummatching; $count++)
    {
     $row = $db->row($linkinfo);
	 $thislink = new onelink('row', $row);
     $displaymatches .= $template->text;
     $displaymatches = linkreplacements($displaymatches, $thislink);
    }
	$template->text = $displaymatches;
   }
   else if ($nummatching == 1)
   { // only one match so go direct to edit form
    if (!$template) $template = new template("../$templatesdir/admin/edit.tpl");
    $row = $db->row($linkinfo);
	$thislink = new onelink('row', $row);
    $hideselector = yesno($thislink->hide);
	$selector = makeselection($settings->categoryselector, $thislink->catid);
	$template->text = linkreplacements($template->text, $thislink);
    $template->replace('{LINKTYPESELECTOR}', typeselector($thislink->type));
    $template->replace('{LINKHIDESELECTOR}', $hideselector);
    $template->replace('{CATSELECTOR}', $selector);
    $template->replace('{RETURNTO}', $returnto);
	$template->replace('{OLDCATID}', $thislink->catid);
   }
   else
   {
    if (!$template) $template = new template("../$templatesdir/redirect.tpl");
    $template->replace('{MESSAGE}', $language->search_nomatch);
    if ($returnto == '') $returnto = 'index.php';   
    $template->replace('{DESTINATION}', $returnto);
   }
  }
 }

 else if ($action == 'member')
 { 
  if ($filled)
  {
    if ($delete=='on')
    {
     if ($id != $thismember->id);
     $amember = new member('id', $id);	
     $result = $amember->deletethis();
     if (!$template) $template = new template("../$templatesdir/redirect.tpl");
     $ourlang = str_replace('{ITEM}', 'member', $language->admin_delete);
     $template->replace('{MESSAGE}', $ourlang);
     if ($returnto == '') $returnto = 'index.php';   
     $template->replace("{DESTINATION}", $returnto);
    }
    else
    {
     $amember = new member('new', '');
	 $amember->language = $thelanguage;
	 $amember->template = $thetemplate;
     if ($newpassword != '') { $amember->password = md5($newpassword);   setcookie ('wsnpass', '"'. $amember->password .'"', (time() + 3000000)); }
     $result = $amember->update('all');
	 $language = new language($thelanguage);
     if (!$template) $template = new template("../$templatesdir/redirect.tpl");
     $ourlang = str_replace('{ITEM}', 'member', $language->admin_edit);
     $template->replace('{MESSAGE}', $language->profile_updated);
     if ($returnto == '') $returnto = 'index.php';   
     $template->replace('{DESTINATION}', $returnto);
    }
  }
  else
  { 
   $memberinfo = getmemberinfo($field, $fieldvalue, $condition);
   $nummatching = $db->numrows($memberinfo);
   if ($nummatching > 1)
   {
    if (!$template) $template = new template("../$templatesdir/admin/searchmembers.tpl");
    for ($count=0; $count<$nummatching; $count++)
    {
     $row = $db->row($memberinfo);
	 $amember = new member('row', $row);
     $displaymatches .= $template->text;
     $displaymatches = memberreplacements($displaymatches, $amember);
    }
	$template->text = $displaymatches;
   }
   else if ($nummatching == 1)
   { // only one match so go direct to edit form
    if (!$template) $template = new template("../$templatesdir/admin/editmembers.tpl");
    $row = $db->row($memberinfo);
	$amember = new member('row', $row);
	$template->text = memberreplacements($template->text, $amember);
	$query = $db->select('id,title', 'membergroupstable', 'id>0', 'ORDER BY id ASC', '');
	$num = $db->numrows($query);
	for ($x=0; $x<$num; $x++)
	{
	 $next = $db->row($query);
	 if ($next[0] == $amember->usergroup)
	   $usergroupoptions .= "<option value=$next[0] selected>$next[1]</option>";
	 else
	   $usergroupoptions .= "<option value=$next[0]>$next[1]</option>";
	}
	$template->replace('{USERGROUPOPTIONS}', $usergroupoptions);
	$langarray = explode(',', $settings->languages);
	$num = sizeof($langarray);
	for ($x=0; $x<$num; $x++)
	{
	 if ($langarray[$x] == $amember->language) $languageoptions .= "<option value='$langarray[$x]' selected>$langarray[$x]</option>";
	 else $languageoptions .= "<option value='$langarray[$x]'>$langarray[$x]</option>";	 
	}
	$template->replace('{LANGUAGEOPTIONS}', $languageoptions);
	$temparray = explode(',', $settings->templates);
	$num = sizeof($temparray);
	for ($x=0; $x<$num; $x++)
	{
	 $thedir = str_replace('templates/', '', $temparray[$x]);
	 if ($temparray[$x] == $amember->template) $tempoptions .= "<option value='$temparray[$x]' selected>$thedir</option>";
	 else $tempoptions .= "<option value='$temparray[$x]'>$thedir</option>";	 
	}
	$template->replace('{TEMPLATEOPTIONS}', $tempoptions);
		
   }
   else
   {
    if (!$template) $template = new template("../$templatesdir/redirect.tpl");
    $template->replace('{MESSAGE}', $language->search_nomatch);
    if ($returnto == '') $returnto = 'index.php';   
    $template->replace('{DESTINATION}', $returnto);
   }
  }
 }

 else if ($action == 'category')
 { // edit info of a category
  if ($filled)
  {
    if ($delete=='on')
    {
     $ourcat = new category('id', $id);
 	 $result = $ourcat->deletethis();	
     if (!$template) $template = new template("../$templatesdir/redirect.tpl");
	 $ourlang = str_replace('{ITEM}', 'category (and all links in it) ', $language->admin_delete);
     $template->replace('{MESSAGE}', $ourlang);
     if (strstr($returnto, $admindir)) $returnto = 'index.php';   
     else $returnto = '../index.php';
     $template->replace('{DESTINATION}', $returnto);
    }
   else
   {
    $ourcat = new category('new', '');
    if (is_array($related)) $ourcat->related = implode('|||', $related);
    $ourcat->related = str_replace('selected', '', $ourcat->related);
    $ourcat->lastedit = time();
    $ourcat->update('all');
    if (!$template) $template = new template("../$templatesdir/redirect.tpl");
    $ourlang = str_replace('{ITEM}', 'category', $language->admin_edit);
    $template->replace('{MESSAGE}', $ourlang);
    if ($returnto == '') $returnto = 'index.php';   
    $template->replace('{DESTINATION}', $returnto);
    // update parentnames and numlinks if subcategory moved
    if (($parent != $oldcategory) && ($parent > 0)) { $ourcat->updateparents(); $ourcat->update('parentids,parentnames'); }
   }
  }
  else
  { 
   $catinfo = getcatinfo($field, $fieldvalue, $condition);
   $nummatching = $db->numrows($catinfo);
   if ($nummatching > 1)
   {
    if (!$template) $template = new template("../$templatesdir/admin/searchcats.tpl");
    for ($count=0; $count<$nummatching; $count++)
    {
     $row = $db->row($catinfo);
	 $thiscat = new category('row', $row);
     $displaymatches .= categoryreplacements($template->text, $thiscat);
    }
    $template->text = $displaymatches;
   }
   else if ($nummatching == 1)
   {
    // get info for category
	$idquery = $db->row($catinfo);
	$thiscat = new category('row', $idquery);
    // display a form through which everything can be modified
    if (!$template) $template = new template("../$templatesdir/admin/editcat.tpl");
    $template->text = categoryreplacements($template->text, $thiscat);
	$selector = catselector($thiscat->parent, 'parent');
    $template->replace('{CATSELECTOR}', $selector);
    $template->replace('{RELATEDCATSELECTOR}', relatedcatselector($thiscat->related));
	$hideyesno = yesno($thiscat->hide);
	$template->replace('{HIDESELECTOR}', $hideyesno);
    $template->replace('{RETURNTO}', $returnto);
	$template->replace('{OLDCATID}', $ourcat->parent);
   }
   else
   {
    if (!$template) $template = new template("../$templatesdir/redirect.tpl");
	$nomatch = str_replace('links', 'categories', $language->search_nomatch);	
    $template->replace('{MESSAGE}', $nomatch);
    if ($returnto == '') $returnto = 'index.php';
    $template->replace('{DESTINATION}', $returnto);
   }
  }
 }
 else if ($action == 'comment')
 { // edit info of a comment
  if ($filled)
  {
   if ($delete=='on')
   {
    $ourcomment = new comment('dummy', $id);
    $result = $ourcomment->deletethis();
    if (!$template) $template = new template("../$templatesdir/redirect.tpl");
    $ourlang = str_replace('{ITEM}', 'comment', $language->admin_delete);
    $template->replace('{MESSAGE}', $ourlang);
    if ($returnto == '') $returnto = 'index.php';   
    $template->replace('{DESTINATION}', $returnto);
   }
   else
   {
    $ourcomment = new comment('new', '');
    $ourcomment->lastedit = time();	
    $ourcomment->update('all');
    if (!$template) $template = new template("../$templatesdir/redirect.tpl");
    $ourlang = str_replace('{ITEM}', 'comment', $language->admin_edit);
    $template->replace('{MESSAGE}', $ourlang);
    if ($returnto == '') $returnto = 'index.php';   
    $template->replace('{DESTINATION}', $returnto);
   }
  }
  else
  { 
   $commentinfo = getcommentinfo($field, $fieldvalue, $condition);
   $nummatching = $db->numrows($commentinfo);
   if ($nummatching > 1)
   {
    if (!$template) $template = new template("../$templatesdir/admin/searchcomments.tpl");
    for ($count=0; $count<$nummatching; $count++)
    {
     $row = $db->row($commentinfo);
	 $thiscomment = new comment('row', $row);
     $displaymatches .= commentreplacements($template->text, $thiscomment);
    }
    $template->text = $displaymatches;
   }
   else if ($nummatching == 1)
   {
    // get info for comment
	$idquery = $db->row($commentinfo);
	$thiscomment = new comment('row', $idquery);
    // display a form through which everything can be modified
    if (!$template) $template = new template("../$templatesdir/admin/editcomments.tpl");
    $template->text = commentreplacements($template->text, $thiscomment);
    $template->replace('{RETURNTO}', $returnto);
   }
   else
   {
    if (!$template) $template = new template("../$templatesdir/redirect.tpl");
	$nomatch = str_replace('links', 'comments', $language->search_nomatch);
    $template->replace('{MESSAGE}', $nomatch);
    if ($returnto == '') $returnto = 'index.php';
    $template->replace('{DESTINATION}', $returnto);
   }
  }
 }
}
require 'adminend.php';

?>