<?php

require 'start.php'; // header stuff

// reconstruct the current url and put it in a cookie, so we can know where to come back to if we go off somewhere soon... but only save it for 15 minutes

if ($settings->dirurl != '') $currenturl = $settings->dirurl .'/index.php';
else $currenturl =  'http://' . $HTTP_SERVER_VARS['SERVER_NAME'] . $HTTP_SERVER_VARS['PHP_SELF'];
$currenturl .= '?'. $HTTP_SERVER_VARS['QUERY_STRING'];

if (($action != 'logout') && ($TID != 'blank') && ($action != 'login'))
{
if (($currenturl != '')&&($HTTP_SERVER_VARS['PHP_SELF'] != '')&&($currenturl != '/?')&&($currenturl != 'http://?')&&($currenturl != 'http:///?'))
setcookie("returnto", "$currenturl",  900);
else
setcookie("returnto", "index.php",  900);
}
if ($action == 'setadminlocation')
{
$adminpath = "http://". $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']);
if (dirname($_SERVER['PHP_SELF']) != '') $adminpath .= "/";
$adminpath .= $admindir .'/index.php?set=1';
header("Location: $adminpath"); 
}


// check to see if we should re-set something
$resetdelay = $settings->resetdelay * 86400; // convert from days to seconds
if (((time() - $resetdelay) > $settings->resettime) && ($setings->resetfields != ''))
{ 
 $settings->resettime = time();
 $settings->update('resettime');
 if (is_array($settings->resetfields)) $toreset = explode(',', $settings->resetfields); else $toreset[0] = $settings->resetfields;
 $num = sizeof($toreset);
 for ($x=0; $x<$num; $x++)
 {
  $db->update('linkstable', $toreset[$x], '0', 'id>0');
 }
}


$linkcolumns = $settings->linkcols;
$catcolumns = $settings->catcols;
$subcatcolumns = $settings->subcatcols;
if ($ascdesc != '') $orderlinks = 'ORDER BY '. $orderlinks .' '. $ascdesc;
if ($orderlinks == '')
{ // let user override value
 $orderlinks = $settings->orderlinks;
}
if ($ordercats == '')
{ // let user override value
 $ordercats = $settings->ordercats;
}
if ($perpage == '')
{ // let user override value
 $perpage = $settings->perpage;
}

// in case someone is being stupid
if ($linkcolumns < 1) $linkcolumns = 1;
if ($catcolumns < 1) $catcolumns = 1;
if ($subcatcolumns < 1) $subcatcolumns = 1;

// deduce needed widths for table cells
$linkwidth = 'width='.(int)(99/$linkcolumns) .'%'; 
$catwidth = 'width='.(int)(99/$catcolumns) .'%';
$subcatwidth = 'width='.(int)(99/$subcatcolumns) .'%';

if ($checkversion == 'docheck')
{
 echo 'WSN Links version 2.35';
}
 
if ($action == 'getvotingcode')
{
 $thislink = new onelink('dummy', $id);
 if (!$template) $template = new template("$templatesdir/showvotecode.tpl");
 $template->replace('{DIRURL}', $settings->dirurl);
 $template->text = linkreplacements($template->text, $thislink);
}
else if (($action == 'displaycat') && ($catid > 0))
{
 // display all the links in the selected category
 if ($page == '') $page = 1;

 $thiscategory = new category('dummy', $catid); // create proper category object
 
 if ($thiscategory->custom != '')
 {
  $custom = $templatesdir .'/'. $thiscategory->custom;
  if (!$template) $template = new template($custom);
 }
 if (!$template) $template = new template('displaylinks.tpl');
 
 $area = $language->title_divider . $thiscategory->name; // supply area for template
 $template->replace('{NAVIGATION}', shownav($thiscategory)); // do navigation
 
 // do related categories
 $relatedtemplate = templateextract($template->text, '<!-- BEGIN RELATED -->', '<!-- END RELATED -->');
 $template->replace($relatedtemplate, '{RELATEDTEMPLATE}');
 $relatedarray = explode('|||', $thiscategory->related);
 if (($thiscategory->related == '') || ($thiscategory->related == ' ')) $num = 0;
 else $num = sizeof($relatedarray);
 for ($x=0; $x<$num; $x++)
 {
  $rcat = new category('id', $relatedarray[$x]);
  $rcompletedtemplate .= categoryreplacements($relatedtemplate, $rcat);
 }  
 $template->replace('{RELATEDTEMPLATE}', $rcompletedtemplate);

 // now do subcategories
 $numsubcats = $thiscategory->numsubcats();
 $subcatsdata = $thiscategory->getsubcats();

 $template_subcats = templateextract($template->text, '<!-- BEGIN SUBCATEGORIES -->', '<!-- END SUBCATEGORIES -->');
 $template->replace($template_subcats, '{SUBCATEGORIES}'); // replace with marker
 if ($numsubcats == 0) $template_subcats = '';

 $columncount = 0;
 for ($count=0; $count<$numsubcats; $count++)
 { // display each subcategory
  $row = $db->row($subcatsdata);
  $nextcat = new category('row', $row);
  if ($columncount == 0)
    $subcatsbody .= '<tr>';
  else if ($columncount==$subcatcolumns)
   {
    $subcatsbody .= '</tr>';
    $columncount = 0;
   }
   $subcatsbody .= $template_subcats;
  $columncount++; 
  $subcatsbody = categoryreplacements($subcatsbody, $nextcat);
 }
 $subcatsbody .= '</tr>';

 // set custom subcat column width
 $width = (int)(100/$subcatcolumns);
 if ($numsubcats < $subcatcolumns)
    $subcatsbody = str_replace('{SUBCATWIDTH}', '', $subcatsbody);
 else
   $subcatsbody = str_replace('{SUBCATWIDTH}', $subcatwidth, $subcatsbody);

 //find total number of validated links for this category, then total recip and total non-recip
 $total = $thiscategory->linkshere();
 $typetotals = explode(',', $settings->linktypes);
 $n = sizeof($typetotals);
 for ($x=0; $x<$n; $x++)
 {
  $var = $typetotals[$x] . 'total';
  $$var = $thiscategory->typetotal($typetotals[$x]);
  $template->replace('{'. strtoupper($var).'}', $$var);
 }

 if ($total == 0)
 {
  $template->replace('{LINKSBODY}', ''); 
  $template->replace('{TOTALINCATEGORY}', '0');
 }

 $start = ($page * $perpage) - $perpage; // have to adjust for starting the numbering at 1
 $end = $start + $perpage -1;

 // get all the templates by cycling through the possibilities
 // link types will be dropdown option on editing link
 // can add/remove through admin panel
 $thetypes = strtoupper($settings->linktypes);
 $listtypes = explode(',', $thetypes);
 $num = sizeof($listtypes);
 for ($count=0; $count<$num; $count++)
 {
  $typex = $listtypes[$count];
  $varname = strtolower($typex) . 'linksbodybase';
  $$varname = templateextract($template->text, "<!-- BEGIN $typex LINKS -->", "<!-- END $typex LINKS -->");
  $template->replace($$varname, '{'. $typex .'LINKSBODY}'); // replace with marker
 }

  $begin = $start;
  $end = $start + $perpage;
  $toshow = $perpage;
  if ( ($total == 0) || ($start >= $end) ) { $linksbodybase = ''; }
  else
  { 
   if ($settings->mixrecip == 'yes')
    $reglinksdata = $thiscategory->linkdata();
   else
    $reglinksdata = $thiscategory->linkdatabytype();
   $columncount=0;
   for ($next=$start; ( ($next<$end) && ($next<$total) ); $next++)
   {
    // get next link
    $row = $db->row($reglinksdata);
    $thelink = new onelink('row', $row);
    $typex = strtoupper($thelink->type);
	if ($columncount == 0)
	{
	 $counter = strtolower($typex) . 'count';
     $templatename = strtolower($typex) . 'linksbodybase';
	 $$counter++;
	 $links = '<tr> '. $$templatename;
	}
    else if ($columncount == $linkcolumns)
    {
	 $counter = strtolower($typex) . 'count';
     $templatename = strtolower($typex) . 'linksbodybase';
	 $$counter++;
	 $links = '</tr> '. $$templatename;
     $columncount = 0;
    }
    else
    {
	 $counter = strtolower($typex) . 'count';
     $templatename = strtolower($typex) . 'linksbodybase';
	 $$counter++;
	 $links = $$templatename;
    }
   $columncount++;
   // do replacements for single link
   if ($settings->mixrecip == 'yes')
   {
    $template_linksbody .= linkreplacements($links, $thelink);
   }
   else
   {
    $thevar = strtolower($thelink->type) . 'linksbody';
	$$thevar .= linkreplacements($links, $thelink);
   }
   $thetotal++;
  }
  // final </tr>
  $template_linksbody .= '</tr>';
  if ($thetotal<$linkcolumns)
    $template_linksbody = str_replace('{LINKWIDTH}', '', $template_linksbody);
  else
    $template_linksbody = str_replace('{LINKWIDTH}', $linkwidth, $template_linksbody);
  }
  
 $num = sizeof($listtypes);
 for ($count=0; $count<$num; $count++)
 {
  $typex = strtoupper($listtypes[$count]);
  if ($settings->mixrecip == 'yes')
  {
   if ($count == 0) $template->replace('{'. $typex .'LINKSBODY}', $template_linksbody);
   else $template->replace('{'. $typex .'LINKSBODY}', '');
  }
  else
  {
   $thevar = strtolower($typex) . 'linksbody';
   $template->replace('{'. $typex . 'LINKSBODY}', $$thevar);
  }
 }  

 
 if ($perpage < 1) $perpage = 1;
 $numpages = ceil($total / $perpage);
 for ($count=1; $count < $page; $count++)
    $previouspages .= $language->pageselection_left. "<a href=index.php?action=displaycat&catid=$catid&page=$count&orderlinks=$sendorder&perpage=$perpage>$count</a>". $language->pageselection_right;
 for ($count=$page; $count<$numpages; $count++)
 {
    $next = $count+1;
    $nextpages .= $language->pageselection_left ."<a href=index.php?action=displaycat&catid=$catid&page=$next&orderlinks=$sendorder&perpage=$perpage>$next</a>". $language->pageselection_right;
 }
 $template->replace('{PREVIOUS}', $previouspages);
 $template->replace('{NEXT}', $nextpages);
 $template->replace('{CURRENTPAGE}', $page);
 $template->replace('{PAGE}', $page);
 $template->replace('{REORDER}', $reorder);
 $template->replace('{PERPAGE}', $perpage);
 $template->replace('{TOTALINCATEGORY}', $total); // total shown in category
 $template->replace('{NUMBEROFSUBCATS}', $numsubcats); // total shown in category
 $template->replace('{SUBCATEGORIES}', $subcatsbody); 
 $template->text = categoryreplacements($template->text, $thiscategory);
}

else // no category selected, so display listing of categories

{
 $thiscategory = new category('dummy', '0'); // top level

 if (!$template) $template = new template('main.tpl');
 // get total number of links and categories
 $condition = 'validated=1 AND hide=0';
 if ($settings->condition != '') $condition .= ' AND '. $settings->condition;    
 $group = $db->select('hits,numcomments', 'linkstable', $condition, '', '');
 $loops = $db->numrows($group);
 for ($count=0; $count<$loops; $count++)
 {
  $row = $db->row($group);
  $totalhits += $row[0];
  $totalcomments += $row[1];
 }
 $validlinks = $loops;
 $totalcats = $thiscategory->numsubcats();
 
 $template->replace('{TOTALLINKS}', $validlinks);
 $template->replace('{TOTALCATS}', $totalcats);
 $template->replace('{TOTALHITS}', $totalhits);
 $template->replace('{TOTALCOMMENTS}', $totalcomments);

 
 $catdata = $thiscategory->getsubcats();


 $catsbodybase = templateextract($template->text, '<!-- BEGIN CATSBODY -->', '<!-- END CATSBODY -->');
 $template->replace($catsbodybase, '{CATSBODY}'); // replace with marker

 for ($currentcat=0; $currentcat<$totalcats; $currentcat++)
 {
 // get info for this category
  $area = $language->title_divider . $language->title_main;
  $row = $db->row($catdata);
  $cat = new category('row', $row); // the category to list next
 // display link to this category
  if ($columncount == 0)
     $template_catsbody .= '<tr>';
  else if ($columncount == $catcolumns)
  {
    $template_catsbody .= '</tr><tr>';
    $columncount = 0;
  }
  $columncount++;

  $template_catsbody .= $catsbodybase;
  $template_catsbody = categoryreplacements($template_catsbody, $cat);
 }
 // final </tr>
 $template_catsbody .= '</tr>';

 if ($totalcats < $catcolumns)
  $template_catsbody = str_replace('{CATWIDTH}', '', $template_catsbody);
 else
  $template_catsbody = str_replace('{CATWIDTH}', $catwidth, $template_catsbody);

 // incorporate into the catsdisplay template
 $template->replace('{TOTALCATS}', $totalshown); // total categories shown
 $template->replace('{CATSBODY}', $template_catsbody);

}

require 'end.php';

?>