<?php
include 'start.php';

$area = $language->title_divider . $language->title_search; // supply area for template

if (!$template) $template = new template('search.tpl');

$search = stripcode($search);

if ($page=='') $page = 1;
$start = ($page * $perpage) - $perpage;
if ($perpage=='') $perpage = $settings->perpage;

 if ($searchfields == '') 
 { 
  $searchfields = $settings->searchfields;
  $searchfields = explode(',', $searchfields);
 }
 $num = sizeof($searchfields);
 $generatesearch = '(validated=1 AND hide=0) AND (';
 if ($settings->condition != '') $generatesearch .= $settings->condition .' AND ';
 if ($catid != '') $generatesearch .= "catid=$catid" .' AND ';
 for ($count=0; $count<$num; $count++)
 {
  $generatesearch .= "$searchfields[$count] LIKE '%$search%'";
  if ($count < ($num-1)) $generatesearch .= " OR ";
 }
 $generatesearch .= ')';
 if ($whichtype == '') $whichtype = 'links'; // allow category or comment or member searches, but links are default
 $getnumber = $db->select($linkfields, $whichtype.'table', "$generatesearch", '', '');
 $numresults = $db->numrows($getnumber); 
 if (($whichtype == 'links') && ($settings->mixrecip == 'no')) $dosearch = $db->select($linkfields, $whichtype.'table', "$generatesearch", 'ORDER BY type ASC', "LIMIT $start,$perpage");
 else $dosearch = $db->select($linkfields, $whichtype.'table', "$generatesearch", '', "LIMIT $start,$perpage");
 $num = $db->numrows($dosearch);
 $searchbody = templateextract($template->text, "<!-- BEGIN SEARCH $whichtype RESULTS -->", "<!-- END SEARCH $whichtype RESULTS -->");
 $template->replace($searchbody, '{RESULTS}'); // replace with marker
 $removeothers = templateextract($template->text, "<!-- BEGIN SEARCH links RESULTS -->", "<!-- END SEARCH links RESULTS -->");
 if ($whichtype != 'links') $template->replace($removeothers, '');
 $removeothers = templateextract($template->text, "<!-- BEGIN SEARCH categories RESULTS -->", "<!-- END SEARCH categories RESULTS -->");
 if ($whichtype != 'categories') $template->replace($removeothers, '');
 $removeothers = templateextract($template->text, "<!-- BEGIN SEARCH comments RESULTS -->", "<!-- END SEARCH comments RESULTS -->");
 if ($whichtype != 'comments') $template->replace($removeothers, '');

 if ($whichtype == 'links')
 {
  $listofem = explode(',', $settings->linktypes);
  $howmany = sizeof($listofem);
  for ($x=0; $x<$howmany; $x++)
  {
   $temp = 'ourtemplate'. $listofem[$x];
   $$temp = templateextract($searchbody, '<!-- BEGIN '. strtoupper($listofem[$x]) .' -->', '<!-- END '. strtoupper($listofem[$x]) .' -->');
   $searchbody = str_replace($$temp, '{'. strtoupper($listofem[$x]) .'TEMP}', $searchbody);
  }
 }
 
 for ($count=0; $count<$num; $count++)
 {  
  $row  =  $db->row($dosearch);
  if ($whichtype == 'links') $thelink = new onelink('row', $row); 
  else if ($whichtype == 'comments') $thelink = new comment('row', $row); 
  else if ($whichtype == 'categories') $thelink = new category('row', $row);
  if ($whichtype == 'links') 
  {
   if ($settings->mixrecip == 'no')
   {
    $thevar = $thelink->type . 'links';
	$temp = 'ourtemplate'. $thelink->type;
	$$thevar .= linkreplacements($$temp, $thelink); 
   }
   else
   {
    $thevar = $thelink->type . 'links';
    $temp = 'ourtemplate'. $thelink->type;
    $results .= linkreplacements($$temp, $thelink); 
   }
  }
  else if ($whichtype == 'categories') $results .= categoryreplacements($searchbody, $thelink); 
  else if ($whichtype == 'comments') $results .= commentreplacements($searchbody, $thelink);     
 }  
 if ($numresults > 0)
 {
  if ($whichtype == 'links')
  {
   if ($settings->mixrecip == 'no')
   {
    $listofem = explode(',', $settings->linktypes);
    $howmany = sizeof($listofem);
    for ($x=0; $x<$howmany; $x++)
    {
     $thevar = $listofem[$x] . 'links'; 

     $searchbody = str_replace('{'. strtoupper($listofem[$x]) .'TEMP}', $$thevar, $searchbody);
    }
    $results = $searchbody;
   }
  }
  $template->replace('{RESULTS}', $results);
 }
 else
  $template->replace('{RESULTS}', '');

if ($numresults == '')
  $template->replace('{NUMRESULTS}', '0');
else
  $template->replace('{NUMRESULTS}', $numresults);

$template->replace('{SEARCHTERM}', $search);  
  
 
 $numpages = ceil($numresults / $perpage);
 $search = urlencode($search);
 for ($count=1; $count < $page; $count++)
   $previouspages .= $language->pageselection_left. "<a href=search.php?page=$count&perpage=$perpage&search=$search>$count</a>". $language->pageselection_right;
 for ($count=$page; $count<$numpages; $count++)
 {
    $next = $count+1;
    $nextpages .= $language->pageselection_left ."<a href=search.php?page=$next&perpage=$perpage&search=$search>$next</a>". $language->pageselection_right;
 }
 $template->replace('{PREVIOUS}', $previouspages);
 $template->replace('{NEXT}', $nextpages);
 $template->replace('{CURRENTPAGE}', $page);
 $template->replace('{PAGE}', $page);
 $template->replace('{PERPAGE}', $perpage);
    
include 'end.php';
?> 