<html>
<head>
<title>WSN Links Upgrade</title>
<link rel="stylesheet" href="templates/style.css" type="text/css">
</head>
<body>

<?php
require 'config.php';
require 'classes/database.php';
require 'classes/category.php';
require 'classes/settings.php';
require 'classes/language.php';
require 'admin/adminfunctions.php';
require 'functions.php';

// make compatable when register_globals is off
while(list($key, $value) = each($HTTP_GET_VARS)) 
{
 $$key = $value;
} 
while(list($key, $value) = each($HTTP_POST_VARS)) 
{
 $$key = $value;
} 

$db = new database;
$settings = new settingsdata;

$password = $settings->password;
if ($userpassword != $password) $userpassword = md5($userpassword);
if (($userpassword == $password) && ($password != ''))
{ // ok, it's the admin, let them upgrade

// add the new stuff
 $sql = fileread('upgrade2.0-2.1.sql');
 $sql = encodesql($sql);
 $sql = str_replace('{CATEGORIESTABLE}', $categoriestable, $sql);
 $sql = str_replace('{LINKSTABLE}', $linkstable, $sql);
 $sql = str_replace('{SETTINGSTABLE}', $metatable, $sql);
 $docreation = processsql($sql);

 $settings->categoryfields .= ',lastlinktime';
 $settings->update('categoryfields');

 // check to be sure they didn't have the language bug from 2.00
 $language = new language;
 if (!(strstr($language->admin_addfieldlink, '{NEWVAR}')))
 {
  // add their missing language

$sql = "INSERT INTO $languagetable VALUES (56, 'vote_cannotvote', 'Sorry, you don&#39;t have permission to vote. Make sure you&#39;re logged in.');
INSERT INTO $languagetable VALUES (35, 'vote_alreadyvoted', 'You&#39;ve already voted, you can&#39;t vote again.');
INSERT INTO $languagetable VALUES (47, 'admin_addfieldlink', '&lt;textarea cols=70 rows=15&gt;Your new links field, {NEWVAR}, has been added... but templates could not be properly updated, so you&#39;ll have to do this manually.

The template variable for your new {TYPE} field is {NEWTEMPVAR}. Use this in your link display templates.

In order to allow yourself to edit this link variable, add this to your &#34;edit link&#34; template next to the similar lines: &lt;input type=text name={NEWVAR} value=&#34;{NEWTEMPVAR}&#34;&gt;. If you prefer not to make this editable, instead use &lt;input type=hidden name={NEWVAR} value=&#34;{NEWTEMPVAR}&#34;&gt; 

If you want the user to be able to submit this field, add &lt;input type=text name={NEWVAR}&gt; to your &#34;suggest link&#34; template.

To make this field searchable, add {NEWVAR} to the list of searchable links fields in your admin prefernces section.&lt;/textarea&gt;');
INSERT INTO $languagetable VALUES (48, 'admin_addfieldcat', '&lt;textarea cols=70 rows=15&gt;Your new category field, {NEWVAR}, has been added... but templates could not be properly updated, so you&#39;ll have to do this manually.

The template variable for your new category field is {NEWTEMPVAR}. Use this in your category display templates for both categories and subcategories.

In order to allow yourself to edit this category variable, add this to your &#34;edit category&#34; template next to the similar lines: &lt;input type=text name={NEWVAR} value=&#34;{NEWTEMPVAR}&#34;&gt;. If you prefer that it not be editable, use this instead: &lt;input type=hidden name={NEWVAR} value=&#34;{NEWTEMPVAR}&#34;&gt;

If you want the user to be able to submit this field, add &lt;input type=text name={NEWVAR}&gt; to your &#34;suggest category&#34; template.&lt;/textarea&gt;');
INSERT INTO $languagetable VALUES (49, 'admin_addfieldsetting', '&lt;textarea cols=70 rows=15&gt;Your new setting, {NEWVAR}, has been added... but templates could not be properly updated, so you&#39;ll have to do this manually.

In order to allow yourself to edit this setting, add this to your &#34;settings&#34; template next to the similar lines: &lt;input type=text name={NEWVAR} value=&#34;{NEWTEMPVAR}&#34;&gt;&lt;/textarea&gt;');
INSERT INTO $languagetable VALUES (68, 'admin_addfieldworked', 'Your new {TYPE} field, {NEWVAR}, has been added. Other templates have been automatically modified for you, but you must also place the template variable {NEWTEMPVAR} it in your {TYPE} display template(s) wherever you want this field to be displayed to visitors. (If you don&#39;t want to display it to visitors, then you&#39;re done.)');
INSERT INTO $languagetable VALUES (53, 'loggedout', 'You&#39;ve logged out. Click &lt;a href=index.php&gt;here&lt;/a&gt; to login again or &lt;a href=../index.php&gt;here&lt;/a&gt; to view your links directory as a visitor.');
INSERT INTO $languagetable VALUES (54, 'comments_cannotpost', 'Sorry, you don&#39;t have permission to post. Make sure you&#39;re logged in.');
INSERT INTO $languagetable VALUES (55, 'emaillink_cannotemail', 'Sorry, you don&#39;t have permission to email a link. Make sure you&#39;re logged in.');
INSERT INTO $languagetable VALUES (57, 'admin_addfieldcomment', '&lt;textarea cols=70 rows=15&gt;Your new comment field, {NEWVAR}, has been added... but templates could not be properly updated, so you&#39;ll have to do this manually.

The template variable for your new comment field is {NEWTEMPVAR}. Use this in your comment display template.

In order to allow yourself to edit this comment variable, add this to your &#34;edit comments&#34; template next to the similar lines: &lt;input type=text name={NEWVAR} value=&#34;{NEWTEMPVAR}&#34;&gt;. If you prefer that it not be editable, use &lt;input type=hidden name={NEWVAR} value=&#34;{NEWTEMPVAR}&#34;&gt; instead.

If you want the user to be able to submit this field, add &lt;input type=text name={NEWVAR}&gt; to your comments template.&lt;/textarea&gt;');
INSERT INTO $languagetable VALUES (56, 'vote_cannotvote', 'Sorry, you don&#39;t have permission to vote. Make sure you&#39;re logged in.');";
 $sql = encodesql($sql);
 $docreation = processsql($sql);
 }

 echo "Upgrade complete. <a href=index.php>View</a> or <a href=admin/index.php>administrate</a>.";
}
else // hasn't given correct password yet
{
 $message = "<p>This will upgrade your WSN Links database info from version 2.0x to version 2.1... it will not harm any existing data. If you're upgrading from version 1.x, please use <a href=upgrade1.2-2.0.php>upgrade1.2-2.0.php</a>, <a href=upgrade1.1-1.2.php>upgrade1.1-1.2.php</a> and <a href=upgrade1.0-1.1.php>upgrade1.0-1.1.php</a> in order as needed according to what version you're upgrading from... then you'll be able to return to this upgrade script. (Doing upgrades in the wrong order will damage your database structure.)</p>
<form action=upgrade2.0-2.1.php method=post>
Please supply your existing WSN Links admin password to confirm your identity:<br>
<table>
<tr><td>Your password:</td>
<td><input type=password name=userpassword size=10></td></tr>
<tr><td colspan=2><input type=submit value=Upgrade></td></tr>
</form>";
 echo $message;
}

mysql_close($connection);
echo mysql_error();
?>

</body>
</html>
