UPDATE {PREFIX}language SET content='You have logged out. <a href=index.php>Return to directory</a>' WHERE name='loggedout';
ALTER TABLE {PREFIX}links ADD `hide` INT NOT NULL default '0';
ALTER TABLE {PREFIX}links ADD `ownerid` INT NOT NULL default '0';
ALTER TABLE {PREFIX}links ADD `hitsin` INT NOT NULL default '0';
ALTER TABLE {PREFIX}links ADD `voterips` text NOT NULL;
ALTER TABLE {PREFIX}links ADD `voterids` text NOT NULL;
ALTER TABLE {PREFIX}categories ADD `custom` text NOT NULL;
ALTER TABLE {PREFIX}comments ADD `ip` text NOT NULL;
ALTER TABLE {PREFIX}comments ADD `ownerid` INT NOT NULL default '0';
ALTER TABLE {PREFIX}language ADD `groupid` INT NOT NULL default '0';

   create table {PREFIX}members
 (
     id int default '0' NOT NULL auto_increment,
       name text NOT NULL,
       links int default '0' NOT NULL,
       comments int default '0' NOT NULL,
       time text NOT NULL,
       usergroup int default '0' NOT NULL,
       password text NOT NULL,
       ip text NOT NULL,
       totalhits int default '0' NOT NULL,
       totalhitsin int default '0' NOT NULL,
       email text NOT NULL,
 UNIQUE KEY id (id)
   );
   
create table {PREFIX}membergroups
 (
     id int auto_increment,
       title text,
       caneditown int,
       caneditall int,
       canvote int,
       isadmin int,
       canpost int,
       canemail int,
       validatecats int,
       validatecomments int,
       validatelinks int,
 UNIQUE KEY id (id)
   );
INSERT INTO {PREFIX}language(id,name,value,groupid) VALUES ('', 'admin_addfieldmember', '&lt;textarea cols=70 rows=15&gt;Your new member field, {NEWVAR}, has been added... but templates could not be properly updated, so you&#39;ll have to do this manually.

The template variable for your new {TYPE} field is {NEWTEMPVAR}. Use this in your member display templates.

In order to allow yourself to edit this member variable, add this to your &#34;edit member&#34; template next to the similar lines: &lt;input type=text name={NEWVAR} value=&#34;{NEWTEMPVAR}&#34;&gt;. If you prefer not to make this editable, instead use &lt;input type=hidden name={NEWVAR} value=&#34;{NEWTEMPVAR}&#34;&gt; 

If you want the user to be able to submit this field, add &lt;input type=text name={NEWVAR}&gt; to your &#34;register&#34; template.&lt;/textarea&gt;', '0'); 
INSERT INTO {PREFIX}language(id,name,value,groupid) VALUES ('', 'passwordreset_failed', 'There is no user registered with that email address.', '0'); 
INSERT INTO {PREFIX}language(id,name,value,groupid) VALUES ('', 'email_passwordresetsubject', 'Your new password', '0'); 
INSERT INTO {PREFIX}language(id,name,value,groupid) VALUES ('', 'email_passwordresetbody', 'Your username is {MEMBERNAME}.
This is your new password: {NEWPASSWORD}', '0'); 
INSERT INTO {PREFIX}language(id,name,value,groupid) VALUES ('', 'passwordreset_worked', 'Your new password has been emailed to you.', '0'); 
INSERT INTO {PREFIX}language(id,name,value,groupid) VALUES ('', 'title_register', 'Registration', '0'); 
INSERT INTO {PREFIX}language(id,name,value,groupid) VALUES ('', 'register_worked', 'Your registration was succesful, you are now logged in.', '0'); 
INSERT INTO {PREFIX}language(id,name,value,groupid) VALUES ('', 'login_worked', 'You are now logged in.', '0'); 
INSERT INTO {PREFIX}language(id,name,value,groupid) VALUES ('', 'login_failed', 'The password you supplied does not match the one for that username.', '0'); 
INSERT INTO {PREFIX}language(id,name,value,groupid) VALUES ('', 'register_mismatch', 'The passwords you types did not match. You must type the same password in both boxes to confirm.', '0'); 
INSERT INTO {PREFIX}language(id,name,value,groupid) VALUES ('', 'admin_usergroupsdone', 'The usergroup has been {TYPE}.', '0'); 
INSERT INTO {PREFIX}members(id,name,password,usergroup,time,links,comments,ip) VALUES ('1', '{USERNAME}', '{PASSWORD}', '3', '{TIME}', '0', '0', '{IP}'); 
INSERT INTO {PREFIX}membergroups(id,title,caneditown,canpost,caneditall,canvote,isadmin,canemail,validatecats,validatecomments,validatelinks) VALUES ('1', 'guest', '0', '1', '0', '1', '0', '0', '1', '1', '1'); 
INSERT INTO {PREFIX}membergroups(id,title,caneditown,canpost,caneditall,canvote,isadmin,canemail,validatecats,validatecomments,validatelinks) VALUES ('2', 'member', '1', '1', '0', '1', '0', '1', '1', '0', '1'); 
INSERT INTO {PREFIX}membergroups(id,title,caneditown,canpost,caneditall,canvote,isadmin,canemail,validatecats,validatecomments,validatelinks) VALUES ('3', 'admin', '1', '1', '1', '1', '1', '1', '0', '0', '0'); 
INSERT INTO {PREFIX}settings(id,name,content) VALUES ('', 'usergroupfields', 'id,title,caneditown,canpost,caneditall,canvote,isadmin,canemail,validatecats,validatecomments,validatelinks'); 
INSERT INTO {PREFIX}settings(id,name,content) VALUES ('', 'memberfields', 'id,name,password,usergroup,time,links,comments,ip,totalhits,totalhitsin,email');
INSERT INTO {PREFIX}settings(id,name,content) VALUES ('', 'clicktimer', ''); 
INSERT INTO {PREFIX}language(id,name,value,groupid) VALUES ('', 'email_rejectsubject', 'Your link has been rejected', '0'); 
INSERT INTO {PREFIX}language(id,name,value,groupid) VALUES ('', 'email_rejectbody', 'The link you submitted, {LINKTITLE} ( {LINKURL} ), has been rejected.
{REASON}', '0'); 
