<html>
<head>
<title>WSN Links Upgrade</title>
<link rel="stylesheet" href="templates/style.css" type="text/css">
</head>
<body>

<?php
require 'config.php';
require 'classes/database.php';
require 'classes/category.php';
require 'classes/settings.php';
require 'classes/language.php';
require 'classes/member.php';
require 'admin/adminfunctions.php';
require 'functions.php';

// make compatable when register_globals is off
while(list($key, $value) = each($HTTP_GET_VARS)) 
{
 $$key = $value;
} 
while(list($key, $value) = each($HTTP_POST_VARS)) 
{
 $$key = $value;
} 

$db = new database;
$settings = new settingsdata;

$canpass = false;
if ($username != '')
{ 
 $query = $db->select('password,usergroup', 'memberstable', "name='$username'", '', '');
 $row = $db->row($query);
 $truepass = $row[0];
 $group = $row[1];
 if ((md5($password) == $truepass) && ($group == "3")) $canpass = true;
}

if ( ($getgoing) && ($canpass) )
{ // ok, it's the admin, let them upgrade
 // add the new stuff
 if (!strstr($settings->memberfields, 'totalhitsin'))
 { // this is just in case they used the early defective 2.1-2.2 upgrade
  $test = $db->query("ALTER TABLE $memberstable ADD totalhits int default '0' NOT NULL;");
  $test = $db->query("ALTER TABLE $memberstable ADD email text NOT NULL;");
  $test = $db->query("ALTER TABLE $memberstable ADD totalhitsin int default '0' NOT NULL;");
  $settings->memberfields .= ',totalhits,totalhitsin,email';
  $settings->update('memberfields');
 }

 $sql = fileread('upgrade2.2-2.3.sql');
 $sql = encodesql($sql);
 $sql = str_replace('{CATEGORIESTABLE}', $categoriestable, $sql);
 $sql = str_replace('{LINKSTABLE}', $linkstable, $sql);
 $sql = str_replace('{SETTINGSTABLE}', $metatable, $sql);
 $sql = str_replace('{LANGUAGETABLE}', $languagetable, $sql);
 $sql = str_replace('{PREFIX}', $prefix, $sql);
 $docreation = processsql($sql);

 $test = $db->query("ALTER TABLE $categoriestable ADD reciprocal text NOT NULL;");

 
 $settings = new settingsdata;
 $db->update('languagetable', 'groupid', 'English', "groupid=''");
 if (!strstr($settings->linkfields, 'lastedit')) $settings->linkfields .= ',lastedit,type';
 if (!strstr($settings->categoryfields, 'lastedit')) $settings->categoryfields .= ',moderators,lastedit,headerinfo,related';
 if (!strstr($settings->commentfields, 'lastedit')) $settings->commentfields .= ',lastedit';
 if (!strstr($settings->memberfields, 'validated')) $settings->memberfields .= ',validated,template,language';
 if (!strstr($settings->usergroupfields, 'validateedits'))  $settings->usergroupfields .= ',validateedits,cansubmitlinks,cansubmitcategories,cansubmitcomments,caneditownlinks,caneditowncategories,caneditowncomments,caneditownprofile,caneditalllinks,caneditallcategories,caneditallcomments,caneditallprofiles';
 $settings->usergroupfields = str_replace(',canpost,', ',', $settings->usergroupfields);
 $settings->usergroupfields = str_replace(',caneditall,', ',', $settings->usergroupfields); 
 $settings->usergroupfields = str_replace(',caneditown,', ',', $settings->usergroupfields); 
 $settings->dateformat = '%B %e, %Y';
 $settings->commentsdateformat = '%B %e, %Y - %I:%M %p';
 $settings->update('all');

 $db->update('linkstable', 'lastedit','time', 'id>0');
 $db->update('categoriestable', 'lastedit', 'time', 'id>0');
 $db->update('commentstable', 'lastedit', 'time', 'id>0');
 $db->update('linkstable', 'type', 'recip', 'recip=1');
 $db->update('linkstable', 'type', 'regular', 'recip=0');
 $db->update('memberstable', 'validated', '1', 'id>0');

 $db->update('membergroupstable', 'cansubmitlinks', '1', 'id>0');
 $db->update('membergroupstable', 'cansubmitcategories', '1', 'id>0');
 $db->update('membergroupstable', 'cansubmitcomments', '1', 'id>0');
 $db->update('membergroupstable', 'caneditownlinks', '1', 'id>1');
 $db->update('membergroupstable', 'caneditowncategories', '1', 'id>1');
 $db->update('membergroupstable', 'caneditowncomments', '1', 'id>1');
 $db->update('membergroupstable', 'caneditownprofile', '1', 'id>1');
 $db->update('membergroupstable', 'caneditalllinks', '1', 'id>2');
 $db->update('membergroupstable', 'caneditallcategories', '1', 'id>2');
 $db->update('membergroupstable', 'caneditallcomments', '1', 'id>2');
 $db->update('membergroupstable', 'caneditallprofiles', '1', 'id>2');

 if ($settings->linktypes == '') { $settings->linktypes = 'regular,recip'; $settings->update('linktypes'); }
 echo "<br>Upgrade complete. Please <a href=admin/index.php>administrate</a> to update your usergroup permissions and other settings.";
}
else 
{
 $message = "<p>This will upgrade your WSN Links database info from version 2.2x to version 2.30... it will not harm any existing data. If you're upgrading from an earlier version, please use the appropriate upgrades in order as needed to get your database updated to 2.2x format. Then you'll be able to return to this upgrade script. (Doing upgrades in the wrong order will damage your database structure.)</p>";
if ($prefix == '') $prefix = 'wsnlinks_';
 $message .= "Please supply your administrative username and password below, along with your database tables prefix:<br>
<br><form action=upgrade2.2-2.3.php?debug=1&getgoing=1 method=post>
User name: <input type=text name=username> <br>
Password: <input type=text name=password> <br>
Database prefix: <input type=text name=prefix value='$prefix'> <br>
<input type=submit value=Upgrade>
</form>";

 echo $message;
}

mysql_close($connection);
echo mysql_error();
?>

</body>
</html>
