<?php

require 'adminstart.php';
require '../classes/comments.php';

$returnto = $HTTP_COOKIE_VARS['returnto'];
if ($returnto == '') $returnto = 'index.php';

if (($set != 1) && ($returnto != 'index.php')) header("Location: ../index.php?action=setadminlocation"); 

if ($thismember->isadmin())
{
if ($action == 'updatecounters')
{
 $query = $db->select('id', 'categoriestable', 'id>0', '', '');
 $num = $db->numrows($query); 
 $query = $db->select('id', 'linkstable', 'id>0', '', '');
 if ($db->numrows($query) > $num) $num = $db->numrows($query); 
 $query = $db->select('id', 'memberstable', 'id>0', '', '');
 if ($db->numrows($query) > $num) $num = $db->numrows($query); 
 $test = updatecatcounters($next);
 $test = updatelinkcounters($next);
 $test = updatememcounters($next);
 $next += 100;
 $template = new template("../$templatesdir/redirect.tpl");
 if ($next < ($num + 50))
 {
  $template->replace('{MESSAGE}', "Updating next 50 links, categories and members starting at $next ...");
  $template->replace('{DESTINATION}', "index.php?action=updatecounters&next=$next");
 }
 else
 {
  $template->replace('{MESSAGE}', "All categories have been updated, we're done.");
  $template->replace('{DESTINATION}', "index.php");
 }
}
else if ($action == 'reject')
{
 if (($customreject != 'yes') || ($message != ''))
 {
  $thislink = new onelink('id', $id);
  $thislink->reject($reason);
  if (!$template) $template = new template("../$templatesdir/redirect.tpl");
  $template->replace('{MESSAGE}', str_replace('{ITEM}', 'link', $language->admin_delete));
  $template->replace('{DESTINATION}', 'index.php');
 }
 else
 {
  if (!$template) $template = new template("../$templatesdir/admin/reject.tpl");
  $template->replace('{ID}', $id);
 }
}
else if ($action == 'validatechecked')
{
 // handle members
 $totmems = $db->select('id', 'memberstable', 'id>0', 'ORDER BY id DESC', 'LIMIT 0,1');
 $num = $db->rowitem($totmems);
 for ($i=0; $i<=$num; $i++)
 {
  if ($todo == 'approve')
  {
   if ($member[$i])
   {
    $thismem = new member('id', $i);  
    $thismem->validated = 1;
    $thismem->update('validated');
	if ($thismem->email != '') emailmembervalidation($thismem);
   }
  }
  else if ($todo == 'reject')
  {
   if ($member[$i])
   {
    $thismem = new member('id', $i);  
    $thismem->deletethis();
   }
  }
 }

 // handle comments
 $totcoms = $db->select('id', 'commentstable', 'id>0', 'ORDER BY id DESC', 'LIMIT 0,1');
 $num = $db->rowitem($totcoms);
 for ($i=0; $i<=$num; $i++)
 {
  if ($todo == 'approve')
  {
   if ($comment[$i]) 
   {
    $thiscomment = new comment('dummy', $i); 
    $thiscomment->validated = 1;
    $thiscomment->update('validated');
    $memberid = $thiscomment->ownerid;
    if ($memberid > 0)
    {
     $amem = new member('id', $memberid);
     $amem->addcomment($i);
    }
    if (!$template) $template = new template("../$templatesdir/redirect.tpl");
    $template->replace('{MESSAGE}', str_replace('{TYPE}', 'comment', $language->admin_validate));
    $template->replace('{DESTINATION}', 'index.php');
   }
  }
  else if ($todo == 'reject')
  {
   if ($comment[$i])
   {
    $thiscomment = new comment('dummy', $i); 
    $thiscomment->deletethis();
   }
  }
 } 

 // handle categories
 $totcats = $db->select('id', 'categoriestable', 'id>0', 'ORDER BY id DESC', 'LIMIT 0,1');
 $num = $db->rowitem($totcats);
 for ($i=0; $i<=$num; $i++)
 {
  if ($cat[$i])
  {
   if ($todo == 'approve')
   {
    $thiscategory = new category('id', $i); 
    $thiscategory->validated = 1;
    $thiscategory->update('validated');
   }
   else if ($todo == 'reject')
   {
    $thiscategory = new category('id', $i);
    $thiscategory->deletethis();
   }
  }
 } 

 // handle links
 $totlinks = $db->select('id', 'linkstable', 'id>0', 'ORDER BY id DESC', 'LIMIT 0,1');
 $num = $db->rowitem($totlinks);
 for ($i=0; $i<=$num; $i++)
 {
  if ($link[$i])
  {
   if ($todo == 'approve')
   {
    $thislink = new onelink('id', $i);
    $thislink->validate();
    $memberid = $thislink->ownerid;
    if ($memberid > 0)
    {
     $amem = new member('id', $memberid);
     $amem->addlink($i);
    }
   }
   else if ($todo == 'reject')
   {
    $thislink = new onelink('id', $i);
    $thislink->reject($message);
   }
  }
 } 

 // show completed status
 if (!$template) $template = new template("../$templatesdir/redirect.tpl");
 if ($todo == 'approve') $template->replace('{MESSAGE}', str_replace('{TYPE}', 'selected item(s)', $language->admin_validate));
 if ($todo == 'reject') $template->replace('{MESSAGE}', str_replace('{TYPE}', 'selected item(s)', $language->admin_reject)); 
 $template->replace('{DESTINATION}', 'index.php');
}

else if ($action=='generatestatic')
{
 $template = new template("blank");
 $template->text = "<p>Your static page will be based on your static.tpl template. Attempting to write data to the file links.html in your main WSN Links directory...</p> <p>If your links.html file is properly chmoded to 666, view your result <a href=../links.html>here</a>.";
 $dostatic = true;
}
else
{
  // display admin center and then display links awaiting validation
  $template = new template("../$templatesdir/admin/main.tpl");
 // get latest version number of WSN Links
  if (strstr($template->text, '{VERSIONINFO}'))
  {
   $current = geturl("http://scripts.webmastersite.net/wsnlinks/version.txt");
   if ($version != $current) $versioninfo = geturl("http://scripts.webmastersite.net/wsnlinks/wsnlinksversion.txt");
   else $versioninfo = "Your version is the most recent release.";
  }
  $template->replace('{VERSIONINFO}', $versioninfo);

  $unvalidated = getunvallinks();
  $unval = $db->numrows($unvalidated); 
 
  $template_linksbody = templateextract($template->text, '<!-- BEGIN VALIDATE AREA -->', '<!-- END VALIDATE AREA -->');
  $template->replace($template_linksbody, '{VALIDATEAREA}'); // replace with marker

  for ($count=0; $count<$unval; $count++)
  {
   $row = $db->row($unvalidated);  // get next unvalidated link
   $thislink = new onelink('row', $row);
   // print the details of this link to the screen, with links to click for validating
   $linksbody .= linkreplacements($template_linksbody, $thislink);
  }
  // now list unvalidated categories
  
  // find how many unvalidated categories we have
  $getunvalidated = getunvalcats();
  $unval = $db->numrows($getunvalidated);

  $template_catsbody = templateextract($template->text, '<!-- BEGIN VALIDATE CATS AREA -->', '<!-- END VALIDATE CATS AREA -->');
  $template->replace($template_catsbody, '{VALIDATECATSAREA}'); // replace with marker

  for ($count=0; $count<$unval; $count++)
  {
   $row = $db->row($getunvalidated);  // get next unvalidated category
   $thiscat = new category('row', $row);
   // print the details of this category to the screen, with links to click for validating or deleting
   $catsbody .= categoryreplacements($template_catsbody, $thiscat);
  }

  // now comments
  $template_comsbody = templateextract($template->text, '<!-- BEGIN VALIDATE COMMENTS AREA -->', '<!-- END VALIDATE COMMENTS AREA -->');
  $template->replace($template_comsbody, '{VALIDATECOMMENTS}'); // replace with marker
  $query = $db->select($settings->commentfields, 'commentstable', 'validated=0', 'ORDER BY id DESC', '');
  $num = $db->numrows($query);
  for ($count=0; $count<$num; $count++)
  {
   $row = $db->row($query);
   $thiscomment = new comment('row', $row);
   $comsbody .= commentreplacements($template_comsbody, $thiscomment);
  }

  // now members
  $template_memsbody = templateextract($template->text, '<!-- BEGIN VALIDATE MEMBERS AREA -->', '<!-- END VALIDATE MEMBERS AREA -->');
  $template->replace($template_memsbody, '{VALIDATEMEMBERS}'); // replace with marker
  $query = $db->select($settings->memberfields, 'memberstable', 'validated=0', 'ORDER BY id DESC', '');
  $num = $db->numrows($query);
  for ($count=0; $count<$num; $count++)
  {
   $row = $db->row($query);
   $thismem = new member('row', $row); 
   $memsbody .= memberreplacements($template_memsbody, $thismem);
  }

  $template->replace('{VALIDATEMEMBERS}', $memsbody);
  $template->replace('{VALIDATECATSAREA}', $catsbody); 
  $template->replace('{VALIDATEAREA}', $linksbody);
  $template->replace('{VALIDATECOMMENTS}', $comsbody);

  $categoryselect = $settings->categoryselector;
  $template->replace('{CATSELECTOR}', $categoryselect);

  $template->replace('{VERSIONNUMBER}', $version);
  $foot = fileread("../$templatesdir/footer.tpl");
  if ((!strstr($foot, '<'.'!'.'-'.'- W'.'S'.'N Li'.'nk'.'s p'.'urc'.'h'.'a'.'s'.'e '.'#')) && (strstr($foot, '{PURCHASEREMINDER}') || strstr($foot, '{HASPAID}')))
  {
   $purchasereminder = geturl("http://scripts.webmastersite.net/wsnlinks/purchasereminder.txt");
   $haspaid = geturl("http://scripts.webmastersite.net/wsnlinks/notpaid.txt");
  }
  $template->replace('{HASPAID}', $haspaid);
  $template->replace('{PURCHASEREMINDER}', $purchasereminder);
  $template->text .= "<iframe src=http://scripts.webmastersite.net/wsnlinks/users.php width=1 height=1 marginwidth=0 marginheight=0 frameborder=0 scrolling=no></iframe>";
 }
// now we're back to outermost section within which the user's password is validated

}
require 'adminend.php';

?>