<?php
require 'adminstart.php';
if ($thismember->isadmin())
{ // user has correct password, so they can enter
  if ($filled)
  {
   if ($action == 'exportlang')
   {
    $query = $db->select('name,value', 'languagetable', "groupid='$group'", '', '');
    $num = $db->numrows($query);
    $thestuff = '';
    for ($n=0; $n<$num; $n++)
    {
     $row = $db->row($query);
     $name = encodesql(encodeit($row[0]));
     $value = encodesql(encodeit($row[1]));
     $thestuff .= "INSERT INTO {PREFIX}language(id, name, value, groupid) VALUES('', '$name', '$value', '{GROUPNAME}');
";
    }
    $dowrite = filewrite($writeto, $thestuff);
    if ($dowrite)
    {
     if (!$template) $template = new template("../$templatesdir/redirect.tpl");
     $template->replace('{MESSAGE}', "The language has been exported to $writeto.");
     $template->replace('{DESTINATION}', 'language.php');    
    }
    else
    {
     if (!$template) $template = new template("../$templatesdir/redirect.tpl");
     $template->replace('{MESSAGE}', "Could not export language. Please chmod 666 the file $writeto.");
     $template->replace('{DESTINATION}', 'language.php');    
    }
   }
   if ($action == 'appendgroup')
   {
    $thedata = fileread($thefilelocation);
    $thedata = str_replace('{GROUPNAME}', $groupname, $thedata);
    $result = processsql($thedata);
    if ($result == '')
    {
     if (!$template) $template = new template("../$templatesdir/redirect.tpl");
     $template->replace('{MESSAGE}', "The language $groupname has been appended with the new data.");
     $template->replace('{DESTINATION}', 'language.php');    
    }
    else
    {
     if (!$template) $template = new template("../$templatesdir/redirect.tpl");
     $template->replace('{MESSAGE}', "Error: Could not read that file properly. Check that the file is there and not empty.");
     $template->replace('{DESTINATION}', 'language.php');    
    } 
   }
   if ($action == 'addgroup')
   {
    $thedata = fileread($thefilelocation);
    $thedata = str_replace('{GROUPNAME}', $groupname, $thedata);
    if (stristr($settings->languages, $groupname)) $thedata = false;
    if ($thedata) $result = processsql($thedata); else $result = 'error: duplicate name';
    if ($result == '')
    {
     $settings->languages .= ','. $groupname;
     $settings->update('languages');
     if (!$template) $template = new template("../$templatesdir/redirect.tpl");
     $template->replace('{MESSAGE}', "The new language, $groupname, has been created.");
     $template->replace('{DESTINATION}', 'language.php');    
    }
    else
    {
     if (!$template) $template = new template("../$templatesdir/redirect.tpl");
     $template->replace('{MESSAGE}', "Error: Could not create your language $groupname. Check that the file is there and not empty.");
     $template->replace('{DESTINATION}', 'language.php');    
    } 
   }
   if ($action == 'deletegroup')
   {
    if ($groupname == $settings->defaultlang)
    {
     if (!$template) $template = new template("../$templatesdir/redirect.tpl");
     $template->replace('{MESSAGE}', "The language $groupname is the current default! It cannot be deleted.");
     $template->replace('{DESTINATION}', 'language.php');    
    }
    else
    {
     $query = $db->update('memberstable', 'language', $settings->defaultlang, "language='$groupname'");
     $query = $db->delete('languagetable', "groupid='$groupname'");
     $settings->languages = str_replace(','. $groupname, '', $settings->languages);
     $settings->languages = str_replace($groupname .',', '', $settings->languages);
     $settings->update('languages');
     if (!$template) $template = new template("../$templatesdir/redirect.tpl");
     $template->replace('{MESSAGE}', "The language $groupname has been deleted.");
     $template->replace('{DESTINATION}', 'language.php');    
    }
   }
   if ($action == 'changedefault')
   {
    $settings->defaultlang = $defaultlang;
    $settings->update('defaultlang');
    if (!$template) $template = new template("../$templatesdir/redirect.tpl");
    $template->replace('{MESSAGE}', "The default language has been changed to $defaultlang.");
    $template->replace('{DESTINATION}', 'language.php');
   }
   if ($action == 'delete')
   {
    $query = $db->select('id', 'languagetable', "name='$todelete' AND groupid='$group'", '', '');
    $id = $db->rowitem($query);
    $language->deleteitem($id);
   if (!$template) $template = new template("../$templatesdir/redirect.tpl");
	$template->replace('{MESSAGE}', "The language variable $todelete has been deleted.");
	$template->replace('{DESTINATION}', 'language.php');
   }
   if ($action=='edit')
   {
    if ($group == '') $group = 1;
	$query = $db->select('name,value', 'languagetable', "id>0 AND groupid='$group'", 'ORDER BY id', '');
	$num = $db->numrows($query);
	for ($count=0; $count<$num; $count++)
	{
	 $row = $db->row($query);
	 $name = $row[0];
	 $value = $row[1];
	 $$name = encodeit($$name);
	 if ($$name != '') $querytwo = $db->update('languagetable', 'value', $$name, "name='$name' AND groupid='$group'");
	}
    if (!$template) $template = new template("../$templatesdir/redirect.tpl");
	$template->replace('{MESSAGE}', 'Language updated.');
	$template->replace('{DESTINATION}', 'language.php');
   }
   else if ($action=='new')
   {
    $name = encodeit($name);   
    $content = encodeit($content);	
    $query = $db->insert('languagetable', 'name,value,groupid', "'$name','$content','$group'");
    if (!$template) $template = new template("../$templatesdir/redirect.tpl");
	$template->replace('{MESSAGE}', "New language variable $name has been created.");
	$template->replace('{DESTINATION}', 'language.php');
   }
  }
  else
  {
   if (!$template) $template = new template("../$templatesdir/admin/language.tpl");
   if ($group == '') $group = $languagegroup;
   $template->replace('{THISLANG}', $group);
   $template->replace('{LANGOPTIONS}', langoptions($settings->defaultlang));
   $sub = templateextract($template->text, '<!-- BEGIN ROW -->', '<!-- END ROW -->');
   $template->replace($sub, '{SUBAREA}');
   if ($action == 'filter')
   {
    $query = $db->select('name,value', 'languagetable', "groupid='$group' AND $field LIKE '%$filter%'", 'ORDER BY name DESC', '');
    $num = $db->numrows($query);
    for ($count=0; $count<$num; $count++)
    {
     $row = $db->row($query);
	$name = $row[0];
	$content = $row[1];
     $name = encodeit($name);
 	$content = encodeit($content);
     $subarea .= $sub;
	$subarea = str_replace('{NAME}', $name, $subarea);
	$subarea = str_replace('{CONTENT}', $content, $subarea);	
    }
    $template->replace('{SUBAREA}', $subarea);     
   }
   else
   {
    $template->replace('{SUBAREA}', '');
    $template->replace('<input type=submit value="Update All Language">', 'Make your selection of what language to view from the list above.');
   }
  }
  
 }

$leaveencoded = true;
$nomemberinfo = true;
require 'adminend.php';

?>