<?php

require 'adminstart.php';

if ($thismember->isadmin())
{ // user has correct password, so they can enter
 
  if ($filled)
  {
   if ($preview)
   {
    $templatedata = decodeit($templatedata);
	$template = new template("blank");
    filewrite("../$templatesdir/blank.tpl", $templatedata);
    $templatedata = encodeit($templatedata);
    if (!$width) $width = 800;
    if (!$height) $height = 600;
    echo "<p>Below is a frame which contains your template as it should look at $width x $height. Note that this is only a general preview of the HTML, so none of the specific data is in it... in actual usage, data will be filled in. This is simply to give you an idea of what your design will look like with this template within the context of your header and footer.</p>

<iframe width=$width height=$height src=../index.php?custom=yes&TID=blank></iframe>
 <p>Note: If the frame does not display a preview correctly, you need to chmod 666 your blank.tpl template file.</p> <p align=center><form action=templates.php?filled=1 method=post>
<input type=hidden name=tempfile value=$tempfile>
<textarea name=templatedata rows=15 cols=75>$templatedata</textarea><br>
<input type=checkbox name=preview>Preview again?<br>
<input type=submit value='Confirm Changes'></form></p>";
   die();
   }
   else
   {
    $templatedata = decodeit($templatedata);

    $check = filewrite("../$templatesdir/$tempfile", $templatedata);
    if ($check)
    {
     if (!$template) $template = new template("../$templatesdir/redirect.tpl");
     $template->replace('{MESSAGE}', $language->admin_templateupdate);
     $template->replace('{DESTINATION}', 'templates.php');
    }
    else
    {
     if (!$template) $template = new template("../$templatesdir/redirect.tpl");
     $template->replace('{MESSAGE}', $language->admin_chmod);
     $template->replace('{DESTINATION}', 'templates.php');
    }
   }
  }
  else
  {
   if (!$template) $template = new template("../$templatesdir/admin/templates.tpl");
   if ($TID)
   {  
    if ($ext == '') $ext = 'tpl';
	$tempfile = $TID .'.'. $ext;
	$tempfile = str_replace('-', '/', $tempfile);

    $template->replace('{TEMPFILE}', $tempfile);
    $templatedata = fileread("../$templatesdir/$tempfile");
    $templatedata = htmlspecialchars($templatedata);
    $templatedata = str_replace('}', '&#125;', $templatedata);
    $templatedata = str_replace('{', '&#123;', $templatedata);
    $template->replace('{TEMPLATEDATA}', $templatedata);
   }
   else
   {
    if ($action == 'addset')
	{
	 if (strstr($settings->templates, $newtemplatedir))
	 {
	  $template = new template("../$templatesdir/redirect.tpl");
	  $template->replace('{MESSAGE}', "Could not find that set $newtemplatedir, or it already exists... check the name.");
	  $template->replace('{DESTINATION}', 'templates.php');
	 }
	 else
	 {
	  $settings->templates .= ','. $newtemplatedir;
	  $settings->update('templates');
	  $template = new template("../$templatesdir/redirect.tpl");
	  $template->replace('{MESSAGE}', "Your template set $newtemplatedir has been added.");
	  $template->replace('{DESTINATION}', 'templates.php');	  
	 }
	}
	else if ($action == 'removeset')
	{
	 if ($newtemplatedir == $settings->templatesdir)
	 {
	  $template = new template("../$templatesdir/redirect.tpl");
	  $template->replace('{MESSAGE}', "Cannot remove the default set!");
	  $template->replace('{DESTINATION}', 'templates.php');
	 }
	 else
	 {
	  $settings->templates = str_replace(','. $newtemplatedir, '', $settings->templates);
	  $settings->templates = str_replace($newtemplatedir .',', '', $settings->templates);
	  $settings->update('templates');
	  $query = $db->update('memberstable', 'templates', $settings->templatesdir, "templates='$newtemplatedir'");
	  $template = new template("../$templatesdir/redirect.tpl");
	  $template->replace('{MESSAGE}', "Template set $newtemplatedir has been removed.");
	  $template->replace('{DESTINATION}', 'templates.php');
     }
	}
	else if ($action == 'changedefault')
	{
	 $settings->templatesdir = $defaultdir;
	 $settings->update('templatesdir');
	 $template = new template("../$templatesdir/redirect.tpl");
	 $template->replace('{MESSAGE}', "Default template set is now $defaultdir");
	 $template->replace('{DESTINATION}', 'templates.php');	
	}
    else if ($action == 'listvars')
	{
	 $linkfields = explode(',', $settings->linkfields);
     $num = sizeof($linkfields);
     for ($count=0; $count<$num; $count++) 
     {
      $tempvar = '{LINK'. strtoupper($linkfields[$count]) .'}';
      if ($count>0) $linkvars .= ", ";
	  $linkvars .= "$tempvar";
     }
	 $linkvars .= ", {LINKCATNAME}, {TRACKLINKURL}, {LINKDATE}, {LINKNEW}, {LINKADMIN}";
     $categoryfields = explode(',', $settings->categoryfields);
     $num = sizeof($categoryfields);
     for ($count=0; $count<$num; $count++) 
     {
      $tempvar = '{CAT'. strtoupper($categoryfields[$count]) .'}';
      if ($count>0) $catvars .= ", ";
	  $catvars .= "$tempvar";
     }
	 $catvars .= ", {CATSUBCATS}, {CATPARENTNAME}, {CATHASNEW}, {CATDATE}, {CATLINKSHERE}, {CATADMIN}";
     $memberfields = explode(',', $settings->memberfields);
     $num = sizeof($memberfields);
     for ($count=0; $count<$num; $count++) 
     {
      $tempvar = '&#123;MEMBER'. strtoupper($memberfields[$count]) .'&#125;';
      if ($count>0) $membervars .= ", ";
	  $membervars .= "$tempvar";
     }
	 $membervars .= ", &#123;MEMBERREGDATE&#125;, &#123;MEMBERADMIN&#125;";
     $commentfields = explode(',', $settings->commentfields);
     $num = sizeof($commentfields);
     for ($count=0; $count<$num; $count++) 
     {
      $tempvar = '{COMMENT'. strtoupper($commentfields[$count]) .'}';
      if ($count>0) $commentvars .= ", ";
	  $commentvars .= "$tempvar";
     }
	 $commentvars .= ", {COMMENTDATE}, {COMMENTADMIN}";
	 $ourtemplatevariables = "There are many other template variables you may encounter, but these are the main ones available across many templates:

Link variables:
$linkvars

Category variables:
$catvars

Comment variables:
$commentvars

Member variables:
$membervars

Global template variables (work anywhere):
{&#67;&#65;TOPTIONS} (gives the options data for a dropdown menu of categories, for use within a selector)

All member variables are usable globally. All language can also be used anywhere with a template variable of the form &#123;LANG_NAME}, where NAME is the upcase version of the name of that language. For example, &#123;LANG_TITLE_VOTE}.

Toplists work anywhere except the admin panel:
<!-- BEGIN TOPLIST 1 -->
<&#67;ONFIG>[links/categories/comments/members],[field],[number to display],[ascending/descending],[optional filtering condition], [optional starting number]</&#67;ONFIG>
<a href={LINKURL}>{LINKTITLE}</a>
<br>
<!-- END TOPLIST 1 -->
(All link/category/comment/member variables work in the toplists of their type)
";
     $template->replace('{TEMPLATEDATA}', $ourtemplatevariables);  
	}
	else
	{
     $template->replace('{TEMPLATEDATA}', $language->admin_selecttemplate);    
	}
    $template->replace('{FILENAME}', 'none');
	$template->replace('<input type=submit value="Submit Changes">', '');   
   }
  }
 	 $template->replace('{TEMPLATEOPTIONS}', tempoptions($settings->templatesdir));

 }
 
$leaveencoded = true;
require 'adminend.php';

?>