<?php

class category
{
 
 function category($type, $input)
 { // constructor: (new, x) makes new out of global vars, (x, catid) creates for cat3catid
  global $db, $settings, $moderatorarray; 
  $categorylist = explode(',', $settings->categoryfields);  
  if ($type == 'row')
  {
   $row = $input;
   $num = sizeof($row);
   for ($count=0; $count<$num; $count++)
   {
	$this->$categorylist[$count] = $row[$count];
   }  
  }
  else if ($type == 'new')
  {
   $num = sizeof($categorylist);
   if ($id = '') $id = 0;
   for ($count=0; $count<$num; $count++)
   {
    global $$categorylist[$count];
   }
   for ($count=0; $count<$num; $count++)
   {
    if ($categorylist[$count] == 'headerinfo') 	$this->$categorylist[$count] = encodeit($$categorylist[$count]);
    else $this->$categorylist[$count] = encodeit(stripcode($$categorylist[$count]));
   }  
  }   
  else
  {
   $catid = $input;
   if ($catid > 0)
   {
    $catdata = $db->select($settings->categoryfields, 'categoriestable', "id=$catid", '', '');
    $row = $db->row($catdata);
    $num = sizeof($row);
    for ($count=0; $count<$num; $count++)
    {
 	 $this->$categorylist[$count] = $row[$count];
    }
   }
   else
   {
    $this->id = $catid;
    $this->name = $language->toplevel;
   }
  }
  if ($type != 'new')
  {
   $moderatorarray[$this->id] = $this->moderators;
  }
 }
 
 function add()
 {
  global $db, $settings, $language;
  // generate parentids and parentnames for navigation
  $parentid = $this->parent;
  if ($parentid != 0)
  {
  $query = $db->select('id,name,parent', 'categoriestable', "id=$parentid AND validated=1", '', '');
  $parentdata = $db->row($query);
  $parentids[0] = $parentdata[0];
  $parentnames[0] = $parentdata[1];
  if ($parentids[0] != 0)
  { // hey, we're in a subcategory
     for ($count=1; $parentdata[0] != 0; $count++)
   { 
    $query = $db->select('id,name,parent', 'categoriestable', 'id='. $parentdata[2] .' AND validated=1', '', '');
    $parentdata = $db->row($query);
	if ($parentdata[0] != 0)
	{
     $parentids[$count] = $parentdata[0];	
     $parentnames[$count] = $parentdata[1];
	}
   }
  }
  $this->parentids = implode('|||', $parentids);
  $this->parentnames = implode('|||', $parentnames);
  }
  // end nav generation
 
  $categorystuff = $settings->categoryfields;
  $categorylist = explode(',', $categorystuff);
  $num = sizeof($categorylist);
  for ($count=0; $count<$num; $count++)
  {
   $valuetoadd = "'";
   $valuetoadd .= $this->$categorylist[$count];
   if ($categorylist[$count] == 'time') $valuetoadd .= time();
   if ($categorylist[$count] == 'lastedit') $valuetoadd .= time();
   if ($valuetoadd == '') $valuetoadd = "''";
   $valuetoadd .= "'";
   $valuelist .= $valuetoadd; 
   if ($count<($num-1)) $valuelist .= ',';
  }
 
  $result = $db->insert('categoriestable', $settings->categoryfields, $valuelist);
  updatecategoryselector(); 
  return true;
 }
 
 function deletethis()
 {
  global $db;
  $id = $this->id;
  $result = $db->delete('categoriestable', "id=$id");
  $getlinks = $db->select('id', 'linkstable', "catid=$id", '', '');
  $num = $db->numrows($getlinks);
  for ($x=0; $x<$num; $x++)
  {
   $idnum = $db->rowitem($getlinks);
   $result = $db->delete('commentstable', "linkid=$idnum");
  }
  $result = $db->delete('linkstable', "catid=$id"); // delete all associated links  
  updatecategoryselector();  
  updatelinktotals($this->parent);  
  return $result;
 }
 
 function update($fields)
 {
  global $db, $settings, $language;
  if ($this->id == $this->parent)
  {
  echo "this->id is ". $this->id .' and this->parent is '. $this->parent;
   echo "Error: You're trying to make a category be its own parent. That's not legal, it would create an infinite loop!";
  }
  else
  {
   if ($fields == 'all')
   {
    $categorylist = explode(',', $settings->categoryfields);
    $num = sizeof($categorylist);
    for ($count=1; $count<$num; $count++)
    { // skip id
     if ($categorylist[$count] == 'hide')
     {
      if ($this->hide == 'yes') $this->hide = 1;
      if ($this->hide == 'no') $this->hide = 0;	
     }
     $result = $db->update('categoriestable', $categorylist[$count], encodeit($this->$categorylist[$count]), 'id='. $this->id);
    }
   }
   else
   {
    $categorylist = explode(',', $fields);
    $num = sizeof($categorylist);
    for ($count=0; $count<$num; $count++)
    {
     if ($categorylist[$count] == 'hide')
     {
      if ($this->hide == 'yes') $this->hide = 1;
      if ($this->hide == 'no') $this->hide = 0;	
     }
     $result = $db->update('categoriestable', $categorylist[$count], encodeit($this->$categorylist[$count]), 'id='. $this->id);
    }
   } 
   updatecategoryselector(); 
   updatelinktotals($this->parent);
   global $oldcategory;
   if (($oldcategory != '') && ($oldcategory != $this->id)) updatelinktotals($oldcategory);
  }
  return $result;
 }


function updateparents()
{
 global $db;
 $parentid = $this->parent;
 $query = $db->select('id,name,parent', 'categoriestable', "id=$parentid AND validated=1 AND hide=0", '', '');
 $parentdata = $db->row($query);
 $parentids[0] = $parentdata[0];
 $parentnames[0] = $parentdata[1];
 if ($parentids[0] != 0)
 { // hey, we're in a subcategory
  for ($count=1; $parentdata[0] != 0; $count++)
  { 
   $query = $db->select('id,name,parent', 'categoriestable', 'id='. $parentdata[2] .' AND validated=1', '', '');
   $parentdata = $db->row($query);
   if ($parentdata[0] != 0)
   {
    $parentids[$count] = $parentdata[0];	
    $parentnames[$count] = $parentdata[1];
   }
  }
  $this->parentids = implode('|||', $parentids);
  $this->parentnames = implode('|||', $parentnames);
 }
 return true;
}
 
 function numsubcats()
 {
  global $db;
  $catid = $this->id;
  $getit = $db->select('id', 'categoriestable', "parent=$catid AND validated=1 AND hide=0", '', '');
  $numsubcats = $db->numrows($getit);
  return $numsubcats;
 }
 
 function getsubcats()
 {
  global $ordercats, $settings, $db;
  $catid = $this->id;
  $subcatsdata = $db->select($settings->categoryfields, 'categoriestable', "parent=$catid AND validated=1 AND hide=0", $ordercats, '');
  return $subcatsdata;
 }
 
 function linkdata()
 { 
  global $db, $settings, $orderlinks, $begin, $toshow;
  if ($begin == '') $begin = 0;
  if ($toshow == '') $toshow = 1000;
  $catid = $this->id;
  $condition = "catid=$catid AND hide=0 AND validated=1";
  if ($settings->condition != '') $condition .= ' AND '. $settings->condition;
  $linkdata = $db->select($settings->linkfields, 'linkstable', $condition, $orderlinks, "LIMIT $begin,$toshow");
  return $linkdata;
 }

 function linkdatabytype()
 { 
  global $db, $settings, $orderlinks, $begin, $toshow;
  if ($begin == '') $begin = 0;
  if ($toshow == '') $toshow = 1000;
  $catid = $this->id;
  $condition = "catid=$catid AND hide=0 AND validated=1";
  if ($settings->condition != '') $condition .= ' AND '. $settings->condition;
  $orderlinks = str_replace('ORDER BY ', 'ORDER BY type,', $orderlinks);
  $linkdata = $db->select($settings->linkfields, 'linkstable', $condition, $orderlinks, "LIMIT $begin,$toshow");
  return $linkdata;
 }
 
 function numlinks()
 {
  global $db, $settings;
  if ($this->id == 0)
  {
   $condition = 'validated=1 AND hide=0';
   if ($settings->condition != '') $condition .= ' AND '. $settings->condition;
   $query = $db->select('id', 'linkstable', $condition, '', '');
   $total = $db->numrows($query);
  }
  else
  {
   $total = $this->numlinks;
  }
  return $total;
 }   

 function typetotal($type)
 {
  global $db, $settings;
  $catid = $this->id;
  $condition = "catid=$catid AND validated=1 AND hide=0 AND type='$type'";
  if ($settings->condition != '') $condition .= ' AND '. $settings->condition;
  $doit = $db->select('id', 'linkstable', $condition, '', '');
  $num = $db->numrows($doit);
  return $num;
 }
 
 function linkshere()
 {
  global $db, $settings;
  $here = $this->id;
  $condition = "catid=$here AND hide=0 AND validated=1";
  if ($settings->condition != '') $condition .= ' AND '. $settings->condition;
  $query = $db->select('id', 'linkstable', $condition, '', '');
  $total = $db->numrows($query);
  return $total;
 }
 
 function grandtotal()
 {
  return $this->numlinks;
 }
 
 function subcatlist()
 {
  global $language, $db, $settings;
  $subsection = $this->getsubcats();
  $prenum = $db->numrows($subsection);
  $subcats = '';
  $template = $language->subcats;
  if ($prenum > $settings->maxsubcats) $num = $settings->maxsubcats;  else $num = $prenum;
  for ($count=0; $count<$num; $count++) 
  {
   $row = $db->row($subsection);
   $thisone = new category('row', $row);
   $subcats .= categoryreplacements($template, $thisone);
  } 
  if ($prenum > $settings->maxsubcats) $subcats .= categoryreplacements($language->subcats_more, $this);
  return $subcats;
 }

 function parentname()
 {
  global $db, $language;
  $parentid = $this->parent;
  if ($parentid > 0)
  {
   $get = $db->select('name', 'categoriestable', "id=$parentid", '', '');
   $row = $db->row($get);
   $thename = $row[0];
  }
  else
  {
   $thename = $language->toplevel;
  }
  return $thename;
 }

 function numberrelated()
 {
  if (($this->related == '') || ($this->related == ' '))
  {
   $num = 0;
  }
  else
  {
   $check = explode('|||', $this->related);
   $num = sizeof($check);
  }
  return $num;
 }
 
 function thedate()
 {
  global $settings;
  setlocale(LC_ALL, $settings->locale);  
  $dateformat = $settings->dateformat;
  $thedate = strftime("$dateformat", $this->time);
  if ($this->time == 0) $thedate = '';
  return $thedate;
 }

 function lasteditdate()
 {
  global $settings;
  setlocale(LC_ALL, $settings->locale);  
  $dateformat = $settings->dateformat;
  $thedate = strftime("$dateformat", $this->time);
  if (($this->lastedit < 1) || ($this->lastedit == $this->time))  $thedate = '';
  return $thedate;
 }
 
 function lastlinktime()
 {
  return $this->lastlinktime;
 }

 function linkselector()
 {
  global $settings, $db;
  $query = $db->select('id,title', 'linkstable', 'catid='. $this->id .' AND validated=1 AND hide=0', $settings->orderlinks, '');
  $num = $db->numrows($query);
  for ($x=0; $x<$num; $x++)
  {
   $row = $db->row($query);
   $theoptions .= '<option value='. $row[0] .'>'. $row[1] .'</option>';
  }
  return $theoptions;
 }

 
}

?>