<?php
class template
{
 var $text;
 var $filename;

 function template($file)
 {
  global $settings, $templatesdir;
  if ($file == 'blank')
  {
   $this->text = '';
   $this->filename = 'none';
  }
  else if (! strstr($file, $templatesdir))
  {
   $this->text = fileread("$templatesdir/$file");
   $this->filename = "$templatesdir/$file";
  }
  else
  {
   $this->text = fileread($file);
   $this->filename = $file;
  }
 }
 
 function replace($var, $value)
 {
  $this->text = str_replace($var, $value, $this->text);
 }
 
 function update()
 {
 $filename = '../'. $this->filename;
 $fd = fopen($filename, 'w');
 $check = fwrite ($fd, $this->text);
 fclose ($fd);
 return $check;
 }

 function showwsncodes()
 {
  global $settings;
  $area = templateextract($this->text, '<!-- BEGIN WSN CODES -->', '<!-- END WSN CODES -->');
  $this->text = str_replace($area, '{WSNCODESAREA}', $this->text);
  $codelist = explode('|||', $settings->wsncodes);
  $num = sizeof($codelist);
  for ($p=0; $p<$num; $p++)
  {
   $thiscode = explode(',', $codelist[$p]);
   $original = $thiscode[0];
   $replacement = $thiscode[1];
   $thisline = str_replace('{ORIGINAL}', $original, $area);
   $thisline = str_replace('{REPLACEMENT}', stripall($replacement), $thisline);
   $thestuff .= $thisline;
  }
  if (strlen($settings->wsncodes)<3) $thestuff = '';
  $this->text = str_replace('{WSNCODESAREA}', $thestuff, $this->text);
  return true; 
 }
 
}

?>