<html>
<head>
<title>WSN Links Upgrade</title>
<link rel="stylesheet" href="templates/style.css" type="text/css">
</head>
<body>

<?php
require 'config.php';
require 'classes/database.php';
require 'classes/category.php';
require 'classes/settings.php';
require 'classes/language.php';
require 'admin/adminfunctions.php';
require 'functions.php';

// make compatable when register_globals is off
while(list($key, $value) = each($HTTP_GET_VARS)) 
{
 $$key = $value;
} 
while(list($key, $value) = each($HTTP_POST_VARS)) 
{
 $$key = $value;
} 

$db = new database;
$settings = new settingsdata;

$password = $settings->password;
if ($userpassword != $password) $userpassword = md5($userpassword);
if (($userpassword == $password) && ($password != ''))
{ // ok, it's the admin, let them upgrade

 $newconfigdata = "<";
 $newconfigdata .="?php
  $";
 $newconfigdata .= "memberstable = '$prefix" . "members'; ";
 $newconfigdata .="$";
 $newconfigdata .= "membergroupstable = '$prefix" . "membergroups'; ?";
 $newconfigdata .= ">";

$filename = "config.php";
$fd = fopen($filename, "aw"); // open for append and write
$appendconfig = fwrite($fd, $newconfigdata); // append to file
fclose ($fd); // close file

 if (!$appendconfig)
 {
  echo "Your config.php file is not writeable... you didn't chmod it to 666. Please dowload your config.php, manually paste the following code onto the bottom of it, and then upload the revised version: <br><br> <textbox cols=50 rows=10>$newconfigdata</textbox>";
 }

// add the new stuff
 $sql = fileread('upgrade2.1-2.2.sql');
 $sql = encodesql($sql);
 $sql = str_replace('{CATEGORIESTABLE}', $categoriestable, $sql);
 $sql = str_replace('{LINKSTABLE}', $linkstable, $sql);
 $sql = str_replace('{SETTINGSTABLE}', $metatable, $sql);
 $sql = str_replace('{LANGUAGETABLE}', $languagetable, $sql);
 $sql = str_replace('{PREFIX}', $prefix, $sql);
 $sql = str_replace('{PASSWORD}', $password, $sql);
 $sql = str_replace('{USERNAME}', $username, $sql);

 $docreation = processsql($sql);

 $language = new language;
 $language->admin_validate = "The {TYPE} has been validated, and now appears in the listing.";
 $language->updateitem('admin_validate');

 $settings->linkfields .= ',hide,ownerid,hitsin,voterips,voterids';
 $settings->update('linkfields');
 $settings->categoryfields .= ',custom';
 $settings->update('categoryfields');
 $settings->commentfields .= ',ip,ownerid';
 $settings->update('commentfields');

 if (!$language->subcats)
 {
  // add their missing language
$sql = "INSERT INTO $languagetable VALUES ('', 'subcats', ' [<a href=index.php?action=displaycat&catid={CATID}>{CATNAME}</a>] ');";
 $sql = encodesql($sql);
 $docreation = processsql($sql);
 }


 echo "<br>Upgrade complete. <a href=index.php>View</a> or <a href=admin/index.php>administrate</a>.";
}
else // hasn't given correct password yet
{
 $message = "<p>This will upgrade your WSN Links database info from version 2.1x to version 2.20... it will not harm any existing data. If you're upgrading from an earlier version, please use the appropriate upgrades in order as needed to get your database updated to 2.1x format. Then you'll be able to return to this upgrade script. (Doing upgrades in the wrong order will damage your database structure.)</p>
<form action=upgrade2.1-2.2.php?debug=1 method=post>
Please supply your existing WSN Links admin password to confirm your identity, supply a login name to go with your existing password, and also supply a database tables prefix:<br>
<table>
<tr><td>Your existing password:</td>
<td><input type=password name=userpassword size=10></td></tr>
<tr><td>Choose a login name:</td>
<td><input type=text name=username size=10 value=admin></td></tr>
<tr><td>Tables prefix:</td>
<td><input type=text name=prefix size=10 value=wsnlinks_></td></tr>
<tr><td colspan=2><input type=submit value=Upgrade></td></tr>
</form>";
 echo $message;
}

mysql_close($connection);
echo mysql_error();
?>

</body>
</html>
